//mCPUView.cpp @ app
#include "mCPUView.h"

const BRect BR_mCPUStatusBarFrame		(30, -7, 125, 20);	
const BRect BR_mCPUStatusBarFrame1		(30, -7, 75, 20);	
const BRect BR_mCPUStatusBarFrame2		(80, -7, 125, 20);	

const BRect BR_mCPUBitmapFrame			(3, 4, 32, 30);

const rgb_color mBack = (ui_color(B_PANEL_BACKGROUND_COLOR));
const rgb_color mBlue = {50, 102, 152, 111};
const rgb_color mBlack = {0, 0, 0, 0};
const rgb_color mWhite = {255, 255, 255, 255};

mCPUView::mCPUView(BRect frame, const char *name, uint32 resizeMask, uint32 flags)
			: BView(BRect(0, 0, 130, 30), "mCPUName", B_FOLLOW_LEFT | B_FOLLOW_TOP,
			 B_WILL_DRAW | B_NAVIGABLE | B_PULSE_NEEDED | B_FRAME_EVENTS)
{
MSave savefile("savefile");
MSave loadfile("loadfile");
SetViewColor(mBack);
SetHighColor(mBlack);
SetLowColor(mBlack);
SetDrawingMode(B_OP_OVER);

/*set view size*/
find_directory(B_COMMON_SETTINGS_DIRECTORY, &path);
/* uptimeview place X*/
loadfile.FindFloat(path, SAVEFILE, "cpuview_l", &mViewPlaceX, 0);
/* uptimeview width X*/
loadfile.FindFloat(path, SAVEFILE, "cpuview_w", &mViewWidthX, 100);
MoveTo(mViewPlaceX, 0);
ResizeTo(mViewWidthX, 30);
/*Image Path*/
loadfile.FindString(path, SAVEFILE, "cpuview_icon", &mCPUImagePath, ICON1);

system_info sys_info;
get_system_info(&sys_info);
if (sys_info.cpu_count == 1)
{
/*single*/
B_mCPUStatusBar = new BStatusBar(BR_mCPUStatusBarFrame, "BR_mCPUStatusBarFrame", 0, 0);
B_mCPUStatusBar->SetMaxValue(100);
AddChild(B_mCPUStatusBar);
}
else
{
/*dual*/
B_mCPUStatusBar1 = new BStatusBar(BR_mCPUStatusBarFrame1, "BR_mCPUStatusBar1", 0, 0);
B_mCPUStatusBar1->SetMaxValue(100);
AddChild(B_mCPUStatusBar1);
B_mCPUStatusBar2 = new BStatusBar(BR_mCPUStatusBarFrame2, "BR_mCPUStatusBar2", 0, 0);
B_mCPUStatusBar2->SetMaxValue(100);
AddChild(B_mCPUStatusBar2);
}

/*Get/Set Barcolor*/
loadfile.FindFloat(path, SAVEFILE, "cpuview_color_r", &mBarColor_r, 50);
loadfile.FindFloat(path, SAVEFILE, "cpuview_color_g", &mBarColor_g, 150);
loadfile.FindFloat(path, SAVEFILE, "cpuview_color_b", &mBarColor_b, 255);
rgb_color mStatusBarRGBColor = {mBarColor_r, mBarColor_g, mBarColor_b, 252};
if (sys_info.cpu_count == 1)
{
B_mCPUStatusBar->SetBarColor(mStatusBarRGBColor);
}
else
{
B_mCPUStatusBar1->SetBarColor(mStatusBarRGBColor);
B_mCPUStatusBar2->SetBarColor(mStatusBarRGBColor);
}

mCPUBitmap = BTranslationUtils::GetBitmap(mCPUImagePath.String());
mCPUBitmapView = new BitmapView(mCPUBitmap, BR_mCPUBitmapFrame, "mCPUBitmap");
AddChild(mCPUBitmapView);
}

mCPUView::~mCPUView()
{

}

void mCPUView::MessageReceived(BMessage *message)
{
	switch(message->what)
	{
	default:
	mCPUView::MessageReceived(message);
	break;
	}
}

void mCPUView::Draw(BRect update)
{
system_info sys_info;
get_system_info(&sys_info);
	if (sys_info.cpu_count == 1)
	{
	/*single*/
	mDifActiveTime = ((sys_info.cpu_infos[0].active_time) - mLastActiveTime);
	mDifClockTime = (system_time() - mLastClockTime);
	mLastActiveTime = (sys_info.cpu_infos[0].active_time);
	mLastClockTime = system_time();
	mDrawerString.SetTo("");
	mPercentage = ((mDifActiveTime * 100) / mDifClockTime); 
	mDrawerString << mPercentage;
	B_mCPUStatusBar->Update(-(B_mCPUStatusBar->CurrentValue()) , 0, 0);
	B_mCPUStatusBar->Update(mPercentage, 0, 0);
	}
	else
	{
	/*dual*/
	/*cpu1*/
	mDifActiveTime1 = ((sys_info.cpu_infos[0].active_time) - mLastActiveTime1);
	mDifClockTime1 = (system_time() - mLastClockTime1);
	mLastActiveTime1 = (sys_info.cpu_infos[0].active_time);
	mLastClockTime1 = system_time();
	mDrawerString.SetTo("");
	mPercentage1 = ((mDifActiveTime1 * 100) / mDifClockTime1); 
	mDrawerString << mPercentage1;
	B_mCPUStatusBar1->Update(-(B_mCPUStatusBar1->CurrentValue()), 0, 0);
	B_mCPUStatusBar1->Update(mPercentage1, 0, 0);
	/*cpu2*/
	mDifActiveTime2 = ((sys_info.cpu_infos[1].active_time) - mLastActiveTime2);
	mDifClockTime2 = (system_time() - mLastClockTime2);
	mLastActiveTime2 = (sys_info.cpu_infos[1].active_time);
	mLastClockTime2 = system_time();
	mDrawerString.SetTo("");
	mPercentage2 = ((mDifActiveTime2 * 100) / mDifClockTime2); 
	mDrawerString << mPercentage2;
	B_mCPUStatusBar2->Update(-(B_mCPUStatusBar2->CurrentValue()), 0, 0);
	B_mCPUStatusBar2->Update(mPercentage2, 0, 0);
	}
}

void mCPUView::Pulse()
{
Invalidate();
}
