#include "mRAMView.h"

const BRect BR_mRAMStatusBarFrame		(32, -7, 125, 20);	
const BRect BR_mRamBitmapFrame			(2, 4, 27, 30);

const rgb_color mBack = 				(ui_color(B_PANEL_BACKGROUND_COLOR));
const rgb_color mBlue = 				{50, 102, 152, 111};
const rgb_color mBlack = 				{0, 0, 0, 0};
const rgb_color mWhite = 				{255, 255, 255, 255};

mRAMView::mRAMView(BRect frame, const char *name, uint32 resizeMask, uint32 flags)
			: BView(BRect(130, 0, 260, 30), "mRAMName", B_FOLLOW_LEFT | B_FOLLOW_TOP,
			 B_WILL_DRAW | B_NAVIGABLE | B_PULSE_NEEDED | B_FRAME_EVENTS)
{
MSave savefile("savefile");
MSave loadfile("loadfile");
SetViewColor(mBack);
SetHighColor(mBlack);
SetLowColor(mBlack);
SetDrawingMode(B_OP_OVER);

/*set view size*/
find_directory(B_COMMON_SETTINGS_DIRECTORY, &path);
/* uptimeview place X*/
loadfile.FindFloat(path, SAVEFILE, "ramview_l", &mViewPlaceX, 0);
/* uptimeview width X*/
loadfile.FindFloat(path, SAVEFILE, "ramview_w", &mViewWidthX, 100);
MoveTo(mViewPlaceX, 0);
ResizeTo(mViewWidthX, 30);
/*Image Path*/
loadfile.FindString(path, SAVEFILE, "ramview_icon", &mRAMImagePath, ICON2);

B_mRAMStatusBar = new BStatusBar(BR_mRAMStatusBarFrame, "BR_mRAMStatusBarFrame", 0, 0);
B_mRAMStatusBar->SetMaxValue(100);
AddChild(B_mRAMStatusBar);

mRamBitmap = BTranslationUtils::GetBitmap(mRAMImagePath.String());
mRamBitmapView = new BitmapView(mRamBitmap, BR_mRamBitmapFrame, "mRamBitmap");
AddChild(mRamBitmapView);

/*Get/Set Barcolor*/
loadfile.FindFloat(path, SAVEFILE, "ramview_color_r", &mBarColor_r, 50);
loadfile.FindFloat(path, SAVEFILE, "ramview_color_g", &mBarColor_g, 150);
loadfile.FindFloat(path, SAVEFILE, "ramview_color_b", &mBarColor_b, 255);
rgb_color mStatusBarRGBColor = {mBarColor_r, mBarColor_g, mBarColor_b, 252};
B_mRAMStatusBar->SetBarColor(mStatusBarRGBColor);
}

mRAMView::~mRAMView()
{

}

void mRAMView::MessageReceived(BMessage *message)
{
	switch(message->what)
	{
	default:
	mRAMView::MessageReceived(message);
	break;
	}
}

void mRAMView::Draw(BRect update)
{
get_system_info(&sys_info);
mRamUsagePercent = ((sys_info.used_pages * 100) / sys_info.max_pages);
B_mRAMStatusBar->Update(-(B_mRAMStatusBar->CurrentValue()), 0, 0);
B_mRAMStatusBar->Update(mRamUsagePercent, 0, 0);
mLastRamUsagePercent = mRamUsagePercent;
}

void mRAMView::Pulse()
{
Invalidate();
}
