#include "mSPView.h"

const BRect mSPButton1Frame 			(30, 2, 60, 25);
const BRect mSPButton2Frame 			(65, 2, 95, 25);
const BRect mSPButton3Frame 			(100, 2, 130, 25);
const BRect mSPButton4Frame 			(135, 2, 165, 25);
const BRect mSPButton5Frame 			(170, 2, 200, 25);
const BRect mSPButton6Frame 			(205, 2, 235, 25);
const BRect mSPButton7Frame 			(240, 2, 270, 25);
const BRect BR_mSPBitmapFrame			(2, 4, 27, 30);

const char* mSaveSettingsFilename2 =	"iBarSettings";

const rgb_color mBack = 				(ui_color(B_PANEL_BACKGROUND_COLOR));
const rgb_color mBlue = 				{50, 102, 152, 111};
const rgb_color mBlack = 				{0, 0, 0, 0};
const rgb_color mWhite = 				{255, 255, 255, 255};

mSPView::mSPView(BRect frame, const char *name, uint32 resizeMask, uint32 flags)
			: BView(BRect(460, 0, 924, 30), "mSPName", B_FOLLOW_LEFT | B_FOLLOW_TOP,
			 B_WILL_DRAW | B_NAVIGABLE | B_PULSE_NEEDED | B_FRAME_EVENTS)
{
MSave savefile("savefile");
MSave loadfile("loadfile");
SetViewColor(mBack);
SetHighColor(mBlack);
SetLowColor(mBack);
Updater();
SetDrawingMode(B_OP_COPY);
//SetDrawingMode(B_OP_OVER);

/*set view size*/
find_directory(B_COMMON_SETTINGS_DIRECTORY, &path);
/* spview place X*/
loadfile.FindFloat(path, SAVEFILE, "spview_l", &mViewPlaceX, 0);
/* spview width X*/
loadfile.FindFloat(path, SAVEFILE, "spview_w", &mViewWidthX, 100);
/*Button 1?*/
loadfile.FindBool(path, SAVEFILE, "spview_b1", &mShowButton[0], 1);
/*Button 2?*/
loadfile.FindBool(path, SAVEFILE, "spview_b2", &mShowButton[1], 0);
/*Button 3?*/
loadfile.FindBool(path, SAVEFILE, "spview_b3", &mShowButton[2], 0);
/*Button 4?*/
loadfile.FindBool(path, SAVEFILE, "spview_b4", &mShowButton[3], 1);
/*Button 5?*/
loadfile.FindBool(path, SAVEFILE, "spview_b5", &mShowButton[4], 1);
/*Button 6?*/
loadfile.FindBool(path, SAVEFILE, "spview_b6", &mShowButton[5], 0);
/*Button 7?*/
loadfile.FindBool(path, SAVEFILE, "spview_b7", &mShowButton[6], 1);
/*Image Path*/
loadfile.FindString(path, SAVEFILE, "spview_icon", &mSPImagePath, ICON3);

cout << mViewPlaceX << " - " << mViewWidthX << endl;
MoveTo(mViewPlaceX, 0);
ResizeTo(mViewWidthX, 30);
BRect showframe;
	if (mShowButton[0] == 1)
	{
	showframe = mSPButton1Frame;
	mSPButtonPlayP = new BButton(showframe, "mSPButtonPlayP", "P", new BMessage(MSG_P));
	AddChild(mSPButtonPlayP);
	usedframes = 1;
	mSPBubbleTips[0].SetTo("Previous Song");
	} else {
	usedframes = 0;
	}
	
	if (mShowButton[1] == 1)
	{
		switch (usedframes)
		{
		case 0:
			showframe = mSPButton1Frame;
			mSPBubbleTips[0].SetTo("Fast Backwards");
		break;
		case 1:
			showframe = mSPButton2Frame;
			mSPBubbleTips[1].SetTo("Fast Backwards");
		break;
		}
	mSPButtonPlayFB = new BButton(showframe, "mSPButtonPlayFB", "FB", new BMessage(MSG_FB));
	AddChild(mSPButtonPlayFB);
	usedframes++;
	}
	
	if (mShowButton[2] == 1)
	{
		switch (usedframes)
		{
		case 0:
			showframe = mSPButton1Frame;
			mSPBubbleTips[0].SetTo("Play Backwards");
		break;
		case 1:
			showframe = mSPButton2Frame;
			mSPBubbleTips[1].SetTo("Play Backwards");
		break;
		case 2:
			showframe = mSPButton3Frame;
			mSPBubbleTips[2].SetTo("Play Backwards");
		break;
		}
	mSPButtonPlayB = new BButton(showframe, "mSPButtonPlayB", "B", new BMessage(MSG_B));
	AddChild(mSPButtonPlayB);
	usedframes++;
	}
	
	if (mShowButton[3] == 1)
	{
		switch (usedframes)
		{
		case 0:
			showframe = mSPButton1Frame;
			mSPBubbleTips[0].SetTo("Stop");
		break;
		case 1:
			showframe = mSPButton2Frame;
			mSPBubbleTips[1].SetTo("Stop");
		break;
		case 2:
			showframe = mSPButton3Frame;
			mSPBubbleTips[2].SetTo("Stop");
		break;
		case 3:
			showframe = mSPButton4Frame;
			mSPBubbleTips[3].SetTo("Stop");
		break;
		}
	mSPButtonStop = new BButton(showframe, "mSPButtonStop", "S", new BMessage(MSG_S));
	AddChild(mSPButtonStop);
	usedframes++;
	}
	
	if (mShowButton[4] == 1)
	{
		switch (usedframes)
		{
		case 0:
			showframe = mSPButton1Frame;
			mSPBubbleTips[0].SetTo("Play (Forward)");
		break;
		case 1:
			showframe = mSPButton2Frame;
			mSPBubbleTips[1].SetTo("Play (Forward)");
		break;
		case 2:
			showframe = mSPButton3Frame;
			mSPBubbleTips[2].SetTo("Play (Forward)");
		break;
		case 3:
			showframe = mSPButton4Frame;
			mSPBubbleTips[3].SetTo("Play (Forward)");
		break;
		case 4:
			showframe = mSPButton5Frame;
			mSPBubbleTips[4].SetTo("Play (Forward)");
		break;
		}
	mSPButtonPlayF = new BButton(showframe, "mSPButtonPlayF", "F", new BMessage(MSG_F));
	AddChild(mSPButtonPlayF);
	usedframes++;
	}
	
	if (mShowButton[5] == 1)
	{
		switch (usedframes)
		{
		case 0:
			showframe = mSPButton1Frame;
			mSPBubbleTips[0].SetTo("Fast Forward");
		break;
		case 1:
			showframe = mSPButton2Frame;
			mSPBubbleTips[1].SetTo("Fast Forward");
		break;
		case 2:
			showframe = mSPButton3Frame;
			mSPBubbleTips[2].SetTo("Fast Forward");
		break;
		case 3:
			showframe = mSPButton4Frame;
			mSPBubbleTips[3].SetTo("Fast Forward");
		break;
		case 4:
			showframe = mSPButton5Frame;
			mSPBubbleTips[4].SetTo("Fast Forward");
		break;
		case 5:
			showframe = mSPButton6Frame;
			mSPBubbleTips[5].SetTo("Fast Forward");
		break;
		}
	mSPButtonPlayFF = new BButton(showframe, "mSPButtonPlayFF", "FF", new BMessage(MSG_FF));
	AddChild(mSPButtonPlayFF);
	usedframes++;
	}

	if (mShowButton[6] == 1)
	{
		switch (usedframes)
		{
		case 0:
			showframe = mSPButton1Frame;
			mSPBubbleTips[0].SetTo("Next Song");
		break;
		case 1:
			showframe = mSPButton2Frame;
			mSPBubbleTips[1].SetTo("Next Song");
		break;
		case 2:
			showframe = mSPButton3Frame;
			mSPBubbleTips[2].SetTo("Next Song");
		break;
		case 3:
			showframe = mSPButton4Frame;
			mSPBubbleTips[3].SetTo("Next Song");
		break;
		case 4:
			showframe = mSPButton5Frame;
			mSPBubbleTips[4].SetTo("Next Song");
		break;
		case 5:
			showframe = mSPButton6Frame;
			mSPBubbleTips[5].SetTo("Next Song");
		break;
		case 6:
			showframe = mSPButton7Frame;
			mSPBubbleTips[6].SetTo("Next Song");
		break;
		}
	mSPButtonPlayN = new BButton(showframe, "mSPButtonPlayN", "N", new BMessage(MSG_N));
	AddChild(mSPButtonPlayN);
	usedframes++;
	}
	
		switch (usedframes)
		{
		case 0:
			X = 35;
		break;
		case 1:
			X = 70;
		break;
		case 2:
			X = 105;
		break;
		case 3:
			X = 145;
		break;
		case 4:
			X = 175;
		break;
		case 5:
			X = 220;
		break;
		case 6:
			X = 255;
		break;
		case 7:
			X = 290;
		break;
		}

mSPBitmap = BTranslationUtils::GetBitmap(mSPImagePath.String());
mSPBitmapView = new BitmapView(mSPBitmap, BR_mSPBitmapFrame, "mSPBitmap");
AddChild(mSPBitmapView);

}

mSPView::~mSPView()
{

}

void mSPView::MessageReceived(BMessage *message)
{
	switch(message->what)
	{
	default:
	mSPView::MessageReceived(message);
	break;
	}
}
/**********************************************************/
void mSPView::Draw(BRect update)
{	
printf("%s\n", buf);
mDrawString.SetTo(buf2);
mDrawString2.SetTo(buf);
MovePenTo(X, 10);
DrawString(mDrawString2.String());
MovePenTo(X, 25);
DrawString(mDrawString.String());
}

void mSPView::Pulse()
{
Updater();
}

void mSPView::Updater()
{
CMDLine = 0;
	BMessage question(B_GET_PROPERTY);
	BMessage answer;
	question.AddSpecifier("info");
	question.AddSpecifier("track",int32(CMDLine));
	if(B_OK==BMessenger("application/x-vnd.marcone-soundplay").SendMessage(&question, &answer,2E6,2E6))
	{
		double pitch;
		double time;
		double totaltime;
		double bitrate;
		const char *name;
		
		buf[0] = '\0';

		if(	B_OK==answer.FindDouble("pitch",&pitch) &&
			B_OK==answer.FindDouble("abspos",&time) &&
			B_OK==answer.FindDouble("length",&totaltime) &&
			B_OK==answer.FindDouble("bitrate",&bitrate) &&
			B_OK==answer.FindString("name",&name))
		{

			if(answer.FindBool("unknownlength"))
			{
			sprintf(buf, "\"%s\"",name);
			sprintf(buf2, "unknownlength");
			}
			else 
			{
			sprintf(buf, "\"%s\" ", name);
			sprintf(buf2, "%ld:%02ld/%ld:%02ld (%ld:%02ld remaining) | %ld kbps",
				int(time)/60,
				int(time)%60,
				int(totaltime)/60,
				int(totaltime)%60,
				int(totaltime-time)/60,
				int(totaltime-time)%60,
				int(bitrate)/1000);
					
				if (strcmp(buf, lastname.String()) == 0) 
				{
				mUpdateRect.Set(X, 12, (X + mViewWidthX), 30);
				}
				else
				{
				mUpdateRect.Set(X, 0, (X + mViewWidthX), 30);
				}
			lastname.SetTo(buf);
			}
		}
	}
Invalidate(mUpdateRect);
}
	