#include "mUptimeView.h"

const BRect BR_mUptimeBitmapFrame		(2, 3, 27, 30);

const rgb_color mBack = 				(ui_color(B_PANEL_BACKGROUND_COLOR));
const rgb_color mBlue = 				{50, 102, 152, 111};
const rgb_color mBlack = 				{0, 0, 0, 0};
const rgb_color mWhite = 				{255, 255, 255, 255};

mUptimeView::mUptimeView(BRect BR_mUptimeView, const char *name, uint32 resizeMask, uint32 flags)
			: BView(BRect(260, 0, 400, 30), "mUptimeName", B_FOLLOW_LEFT | B_FOLLOW_TOP,
			 B_WILL_DRAW | B_NAVIGABLE | B_PULSE_NEEDED | B_FRAME_EVENTS)
{
MSave savefile("savefile");
MSave loadfile("loadfile");
SetViewColor(mBack);
SetHighColor(mBlack);
SetLowColor(mBack);
SetDrawingMode(B_OP_OVER);

/*set view size*/
find_directory(B_COMMON_SETTINGS_DIRECTORY, &path);
/* uptimeview place X*/
loadfile.FindFloat(path, SAVEFILE, "uptimeview_l", &mViewPlaceX, 0);
/* uptimeview width X*/
loadfile.FindFloat(path, SAVEFILE, "uptimeview_w", &mViewWidthX, 100);
MoveTo(mViewPlaceX, 0);
ResizeTo(mViewWidthX, 30);

/*Image Path*/
loadfile.FindString(path, SAVEFILE, "uptimeview_icon", &mUptimeImagePath, ICON4);

mUptimeBitmap = BTranslationUtils::GetBitmap(mUptimeImagePath.String());
mUptimeBitmapView = new BitmapView(mUptimeBitmap, BR_mUptimeBitmapFrame, "mUptimeBitmap");
AddChild(mUptimeBitmapView);

Updater();
}

mUptimeView::~mUptimeView()
{

}

void mUptimeView::MessageReceived(BMessage *message)
{
	switch(message->what)
	{
	default:
	mUptimeView::MessageReceived(message);
	break;
	}
}

void mUptimeView::Draw(BRect update)
{
MovePenTo(30, 15);
DrawString(bs_mDrawString.String());
MovePenTo(30, 25);
DrawString(bs_mDrawString2.String());
PostUpdater();
}

void mUptimeView::Pulse()
{
Updater();
}

void mUptimeView::Updater()
{
system_info sys_info;

bs_mDrawString.SetTo("");
bs_mDrawString2.SetTo("");
uptime = (system_time() / 1000000);
hour = day = sec = min = 0;
if (uptime >= 60)/*More than one minute*/
{

	if (uptime >= (60*60))/*More than one hour*/
	{
		if(uptime >= (60*60*24))/*More than one day*/
		{
		day = uptime / (60*60*24);
		uptime -= (day * (60*60*24));
			if (day == 1)
			{
			bs_day.SetTo(" day ");
			}
			else
			{
			bs_day.SetTo(" days ");
			}
		hour = uptime / (60*60);
		uptime -= (hour * (60*60));
			if (hour == 1)
			{
			bs_hour.SetTo(" hour ");
			}
			else
			{
			bs_hour.SetTo(" hours ");
			}
		min = uptime / (60);
		uptime -= (min * (60));
			if (min == 1)
			{
			bs_min.SetTo(" minute ");
			}
			else
			{
			bs_min.SetTo(" minutes ");
			}
		sec = uptime;
			if (sec == 1)
			{
			bs_sec.SetTo(" second ");
			}
			else
			{
			bs_sec.SetTo(" seconds ");
			}
		bs_mDrawString << day << bs_day.String() << hour << bs_hour.String();
		bs_mDrawString2 << min << bs_min.String() << sec << bs_sec.String();
		}
		else/*More than one hour*/
		{
		day = 0;
		bs_day.SetTo(" days ");
		hour = uptime / (60*60);
		uptime -= (hour * (60*60));
			if (hour == 1)
			{
			bs_hour.SetTo(" hour ");
			}
			else
			{
			bs_hour.SetTo(" hours ");
			}
		min = uptime / (60);
		uptime -= (min * (60));
			if (min == 1)
			{
			bs_min.SetTo(" minute ");
			}
			else
			{
			bs_min.SetTo(" minutes ");
			}
		sec = uptime;
			if (sec == 1)
			{
			bs_sec.SetTo(" second ");
			}
			else
			{
			bs_sec.SetTo(" seconds ");
			}
		bs_mDrawString << day << bs_day.String() << hour << bs_hour.String();
		bs_mDrawString2 << min << bs_min.String() << sec << bs_sec.String();
		}
	}
	else/*More than one minute*/
	{
	day = 0;
	bs_day.SetTo(" days ");
	hour = 0;
	bs_hour.SetTo(" hours ");
	min = uptime / (60);
	uptime -= (min * (60));
		if (min == 1)
		{
		bs_min.SetTo(" minute ");
		}
		else
		{
		bs_min.SetTo(" minutes ");
		}
	sec = uptime;
		if (sec == 1)
		{
		bs_sec.SetTo(" second ");
		}
		else
		{
		bs_sec.SetTo(" seconds ");
		}
	bs_mDrawString << day << bs_day.String() << hour << bs_hour.String();
	bs_mDrawString2 << min << bs_min.String() << sec << bs_sec.String();
	}
	
}
else/*Less than one minute*/
{
day = 0;
bs_day.SetTo(" days ");
hour = 0;
bs_hour.SetTo(" hours");
min = 0;
bs_min.SetTo(" minutes");
sec = uptime;
	if (sec == 1)
	{
	bs_sec.SetTo(" second ");
	}
	else
	{
	bs_sec.SetTo(" seconds ");
	}
bs_mDrawString << day << bs_day.String() << hour << bs_hour.String();
bs_mDrawString2 << min << bs_min.String() << sec << bs_sec.String();
}
Invalidate(BR_mUptimeUpdateRect);
}

/***************************************************/
void mUptimeView::PostUpdater()
{
	if(sec == 59 && min == 59 && hour == 23)
	{
	BR_mUptimeUpdateRect.Set(0, 0, 150, 30);
	}
	else
	{
		if(sec == 59 && min == 59)
		{
		BR_mUptimeUpdateRect.Set(0, 0, 150, 30);
		}
		else
		{
			if(sec == 59)
			{
			BR_mUptimeUpdateRect.Set(0, 15, 150, 30);
			}
			else
			{
			BR_mUptimeUpdateRect.Set(50, 15, 150, 30);
			}
		}
	}
}
