//mWindow.cpp @ App
#include "mWindow.h"
#include "main.h"

const rgb_color mBlue = 					{90, 85, 205};
const rgb_color mDefault = 					{219, 219, 219};
const rgb_color mWhite = 					{255, 255, 255};
const rgb_color mBlack = 					{1, 1, 1, 40};

const char*	mSomethingIsWrong =				"SomethingIsWrong";
const char* mWindowTitle =					"iBar";
const char* mSaveSettingsFilename =			"iBarSettings";

const BRect mWindowRect 					(0, 834, 1024, 864);

//Constructa
mWindow::mWindow(const char *mWindowTitle)
			: BWindow(BRect(mWindowRect), mWindowTitle, B_NO_BORDER_WINDOW_LOOK, B_NORMAL_WINDOW_FEEL, B_NOT_RESIZABLE | B_NOT_MOVABLE | B_WILL_ACCEPT_FIRST_CLICK | B_AVOID_FRONT, B_ALL_WORKSPACES)
{
MSave savefile("savefile");
MSave loadfile("savefile");

BScreen mScreen(B_MAIN_SCREEN_ID);
ScreenResolution.Set((mScreen.Frame().left), (mScreen.Frame().top), (mScreen.Frame().right), (mScreen.Frame().bottom));
SetSizeLimits(20, 1600, 29, 30);

mBubbleTips = spawn_thread(mBubbleTipsThread_static, "I'am watching you",
										B_NORMAL_PRIORITY, this);
resume_thread(mBubbleTips);

/*Determine the width of all of the views */
mCtrlViewWidth = 100;
mWorkViewWidth = 40;
mCPUViewWidth = 130;
mRAMViewWidth = 130;
mUptimeViewWidth = 150;
mUtilViewWidth = 60;
mSPViewWidth = (ScreenResolution.right - (mUtilViewWidth + mUptimeViewWidth + mRAMViewWidth + mCPUViewWidth));
mViewX = 0;

/** We save/load settings  (using my own library (libibar.so))*/
find_directory(B_COMMON_SETTINGS_DIRECTORY, &path);
/* Screenpoint left*/
savefile.AddFloat(path, mSaveSettingsFilename, "screenres_l", ScreenResolution.left, true);
/* Screenpoint top*/
savefile.AddFloat(path, mSaveSettingsFilename, "screenres_t", ScreenResolution.top, true);
/* Screenpoint right*/
savefile.AddFloat(path, mSaveSettingsFilename, "screenres_r", ScreenResolution.right, true);
/* Screenpoint bottom*/
savefile.AddFloat(path, mSaveSettingsFilename, "screenres_b", ScreenResolution.bottom, true);
/* ctrlview width*/
savefile.AddFloat(path, mSaveSettingsFilename, "ctrlview_w", (float)mCtrlViewWidth, true);
/* workview width*/
savefile.AddFloat(path, mSaveSettingsFilename, "workview_w", (float)mWorkViewWidth, true);
/* cpuview width*/
savefile.AddFloat(path, mSaveSettingsFilename, "cpuview_w", (float)mCPUViewWidth, true);
/* ramview width*/
savefile.AddFloat(path, mSaveSettingsFilename, "ramview_w", (float)mRAMViewWidth, true);
/* uptimeview width*/
savefile.AddFloat(path, mSaveSettingsFilename, "uptimeview_w", (float)mUptimeViewWidth, true);
/* utilview width*/
savefile.AddFloat(path, mSaveSettingsFilename, "utilview_w", (float)mUtilViewWidth, true);
/* spview width*/
savefile.AddFloat(path, mSaveSettingsFilename, "spview_w", (float)mSPViewWidth, true);
	
find_directory(B_COMMON_SETTINGS_DIRECTORY, &path);
/* ctrlview bool (show it?) */
loadfile.FindBool(path, SAVEFILE, "ctrlview_bool", &mCtrlViewBool, 1);
/* workview bool (show it?) */
loadfile.FindBool(path, SAVEFILE, "workview_bool", &mWorkViewBool, 1);
/* cpuview bool (show it?) */
loadfile.FindBool(path, SAVEFILE, "cpuview_bool", &mCPUViewShowBool, 1);
/* ramview bool (show it?)*/
loadfile.FindBool(path, SAVEFILE, "ramview_bool", &mRAMViewShowBool, 1);
/* uptimeview bool (show it?)*/
loadfile.FindBool(path, SAVEFILE, "uptimeview_bool", &mUptimeViewShowBool, 1);
/* utilview bool (show it?)*/
loadfile.FindBool(path, SAVEFILE, "utilview_bool", &mUtilViewShowBool, 1);
/* spview bool (show it?)*/
loadfile.FindBool(path, SAVEFILE, "spview_bool", &mSPViewShowBool, 1);
/* Window placement*/
BDeskbar* mDeskBar = new BDeskbar();
	if (mDeskBar->Location() == B_DESKBAR_BOTTOM)
	{
	// if The Deskbar is in the bottom of the screen,
	// the iBar _should_ align top, nomatter what
	savefile.AddBool(path, SAVEFILE, "mwindow_bottom", 0, true);
	mAlignWindowBottom = false;
	}
	else
	{
		if (mDeskBar->Location() == B_DESKBAR_LEFT_BOTTOM)
		{
		loadfile.FindBool(path, SAVEFILE, "mwindow_bottom", &mAlignWindowBottom, 0);
		}
		else
		{
		loadfile.FindBool(path, SAVEFILE, "mwindow_bottom", &mAlignWindowBottom, 1);
		}
	}

/*Set correct placement and size of the window */
	if (mAlignWindowBottom)
	{
	MoveTo(ScreenResolution.left, (ScreenResolution.bottom - 30));
	ResizeTo(ScreenResolution.right, (ScreenResolution.top + 30));
	}
	else
	{
	MoveTo(0, 0);
	ResizeTo(ScreenResolution.right, (ScreenResolution.top + 30));
	}
/* Set The Correct Placement Of Views */
mViewX = 0;
	/*ctrl view*/
	if (mCtrlViewBool)
	{
	mCtrlViewPlace = mViewX;
	mViewX = (mViewX + mCtrlViewWidth);
	cout << "___mCtrlView is enabled___" << endl;
	}
	/*work view*/
	if (mWorkViewBool)
	{
	mWorkViewPlace = mViewX;
	mViewX = (mViewX + mWorkViewWidth);
	cout << "___mWorkView is enabled___" << endl;
	}
	/*cpu view*/
	if (mCPUViewShowBool)
	{
	mCPUViewPlace = mViewX;
	mViewX = (mViewX + mCPUViewWidth);
	cout << "___mCPUView is enabled___" << endl;
	}
	/*ram view*/
	if (mRAMViewShowBool)
	{
	mRAMViewPlace = mViewX;
	mViewX = (mViewX + mRAMViewWidth);
	cout << "___mRAMView is enabled___" << endl;
	}
	/*uptime view*/
	if (mUptimeViewShowBool)
	{
	mUptimeViewPlace = mViewX;
	mViewX = (mViewX + mUptimeViewWidth);
	cout << "___mUptimeView is enabled___" << endl;
	}
	/*util view*/
	if (mUtilViewShowBool)
	{
	mUtilViewPlace = mViewX;
	mViewX = (mViewX + mUtilViewWidth);
	cout << "___mUtilView is enabled___" << endl;
	}
	/*sp view*/
	if (mSPViewShowBool)
	{
	mSPViewPlace = mViewX;
	mViewX = (mViewX + mSPViewWidth);
	cout << "___mSPView is enabled___" << endl;
	}
	
/*Save it (again using libibar)*/
find_directory(B_COMMON_SETTINGS_DIRECTORY, &path);
/* ctrlview left*/
savefile.AddFloat(path, mSaveSettingsFilename, "ctrlview_l", (float)mCtrlViewPlace, true);
/* workview left*/
savefile.AddFloat(path, mSaveSettingsFilename, "workview_l", (float)mWorkViewPlace, true);
/* cpuview left*/
savefile.AddFloat(path, mSaveSettingsFilename, "cpuview_l", (float)mCPUViewPlace, true);
/* ramview left*/
savefile.AddFloat(path, mSaveSettingsFilename, "ramview_l", (float)mRAMViewPlace, true);
/* uptimeview left*/
savefile.AddFloat(path, mSaveSettingsFilename, "uptimeview_l", (float)mUptimeViewPlace, true);
/* utilview left*/
savefile.AddFloat(path, mSaveSettingsFilename, "utilview_l", (float)mUtilViewPlace, true);
/* spview left*/
savefile.AddFloat(path, mSaveSettingsFilename, "spview_l", (float)mSPViewPlace, true);

/******************************/
// Which views to show, and then place the other once in line
mViewX = 0;
	if (mCtrlViewBool)
	{
	mctrlview = new mCtrlView(BRect(mCtrlViewPlace, 0, (mCtrlViewPlace + mCtrlViewWidth), 30), "mCtrlView", B_FOLLOW_TOP, B_WILL_DRAW | B_NOT_RESIZABLE);
	mViewX = mViewX + mCtrlViewWidth;
	AddChild(mctrlview);
	}
	if (mWorkViewBool)
	{
	mworkview = new mWorkView(BRect(mWorkViewPlace, 0, (mWorkViewPlace + mWorkViewWidth), 30), "mWorkView", B_FOLLOW_TOP, B_WILL_DRAW | B_NOT_RESIZABLE);
	mViewX = mViewX + mWorkViewWidth;
	AddChild(mworkview);
	}
	if (mCPUViewShowBool)
	{
	mcpuview = new mCPUView(BRect(mCPUViewPlace, 0, (mCPUViewPlace + mCPUViewWidth), 30), "mCPUView", B_FOLLOW_TOP, B_WILL_DRAW | B_NOT_RESIZABLE);
	mViewX = mViewX + mCPUViewWidth;
	AddChild(mcpuview);
	}
	if (mRAMViewShowBool)
	{
	mramview = new mRAMView(BRect(mRAMViewPlace, 0, (mRAMViewPlace + mRAMViewWidth) , 30), "mRAMView", B_FOLLOW_TOP, B_WILL_DRAW | B_NOT_RESIZABLE);
	mViewX = mViewX + mRAMViewWidth;
	AddChild(mramview);
	}
	if (mUptimeViewShowBool)
	{
	muptimeview = new mUptimeView(BRect(mUptimeViewPlace, 0, (mUptimeViewPlace + mUptimeViewWidth), 30), "mUptimeView", B_FOLLOW_TOP, B_WILL_DRAW | B_NOT_RESIZABLE);
	mViewX = mViewX + mUptimeViewWidth;
	AddChild(muptimeview);
	}
	if (mUtilViewShowBool)
	{
	mutilview = new mUtilView(BRect(mUtilViewPlace, 0, (mUtilViewPlace + mUtilViewWidth), 30), "mUptimeView", B_FOLLOW_TOP, B_WILL_DRAW | B_NOT_RESIZABLE);
	mViewX = mViewX + mUtilViewWidth;
	AddChild(mutilview);
	}
	if (mSPViewShowBool)
	{
	mspview = new mSPView(BRect(mSPViewPlace, 0, (mSPViewPlace + mSPViewWidth), 30), "mUptimeView", B_FOLLOW_TOP, B_WILL_DRAW | B_NOT_RESIZABLE);
	mViewX = mViewX + mSPViewWidth;
	AddChild(mspview);
	}
	else
	//If soundplayview shouldnt be drawn, do not make the window any larger than needed
	{
	ResizeTo(mViewX, 30);
	}
SetPulseRate(1000000);
}

/**************************************************************/
mWindow::~mWindow()
{

}

/**************************************************************/
/**************** BMessages ***********************************/
/**************************	************************************/
void mWindow::MessageReceived(BMessage *message)
{
MSave savefile("savefile");
MSave loadfile("savefile");
find_directory(B_COMMON_SETTINGS_DIRECTORY, &path);
loadfile.FindString(path, SAVEFILE, "execDir", &mExecDir, "/boot/apps/iBar");
mScriptsDir.SetTo(mExecDir.String());
mScriptsDir << "Scripts/";
	switch(message->what)
	{
	case MSG_MIXIMIZE:
		Miximize();
	break;
	case MSG_SETALIGNMENT:
		if (mAlignWindowBottom)
		{
		mAlignWindowBottom = false;
		MoveTo(0, 0);
		ResizeTo(ScreenResolution.right, (ScreenResolution.top + 30));
		}
		else
		{
		mAlignWindowBottom = true;
		MoveTo(ScreenResolution.left, (ScreenResolution.bottom - 30));
		ResizeTo(ScreenResolution.right, (ScreenResolution.top + 30));
		}
		savefile.AddBool(path, mSaveSettingsFilename, "mwindow_bottom", mAlignWindowBottom, true);
	break;
	case MSG_P:
		mScriptFile.SetTo(mScriptsDir.String());
		mScriptFile << "m_previous";
		system(mScriptFile.String());
		mspview->Invalidate();
	break;
	case MSG_FB:
		mScriptFile.SetTo(mScriptsDir.String());
		mScriptFile << "m_fbackward";
		system(mScriptFile.String());
	break;
	case MSG_B:
		mScriptFile.SetTo(mScriptsDir.String());
		mScriptFile << "m_backward";
		system(mScriptFile.String());
	break;
	case MSG_S:
		mScriptFile.SetTo(mScriptsDir.String());
		mScriptFile << "m_pause";
		system(mScriptFile.String());
	break;
	case MSG_F:
		mScriptFile.SetTo(mScriptsDir.String());
		mScriptFile << "m_forward";
		system(mScriptFile.String());
	break;
	case MSG_FF:
		mScriptFile.SetTo(mScriptsDir.String());
		mScriptFile << "m_fforward";
		system(mScriptFile.String());
	break;
	case MSG_N:
		mScriptFile.SetTo(mScriptsDir.String());
		mScriptFile << "m_next";
		system(mScriptFile.String());
	break;
	case MSG_NXTWRK:
		mCurrentWork = current_workspace();
			if ((mCurrentWork + 1) == count_workspaces())
			{
			activate_workspace(0);
			}
			else
			{
			activate_workspace(mCurrentWork + 1);
			}
	break;
	case MSG_PRVWRK:
		mCurrentWork = current_workspace();
			if(mCurrentWork == 0)
			{
			activate_workspace(count_workspaces() - 1);
			}
			else
			{
			activate_workspace(current_workspace() - 1);
			}
	break;
	case MSG_QUIT:
		be_app->PostMessage(B_QUIT_REQUESTED);
	break;
	case MSG_PREF:
	{
		BString mPrefAddr;
		mPrefAddr.SetTo(mExecDir);
		mPrefAddr.Append("/Preferences &");
		system(mPrefAddr.String());
	break;
	}
	case MSG_ABOUT:
	{
		BAlert* mAlert = new BAlert("B_ABOUT_ALERT", 
						"iBar\nVersion Release Candidate 2\nBy Marius Stene\nm_stene@yahoo.com", "OK");
		mAlert->Show();
	break;
	}
	default:
		
	break;
	}
}

/***************************************************/
bool mWindow::QuitRequested()
{
	be_app->PostMessage(B_QUIT_REQUESTED);
	return BWindow::QuitRequested();
}

/***************************************************/
void mWindow::ScreenChanged(BRect ScreenResolution2, color_space ScreenDepth2)
{
	//Set correct placement and size of the window 
	if (mAlignWindowBottom)
	{
	MoveTo(ScreenResolution2.left, (ScreenResolution2.bottom - 30));
	ResizeTo(ScreenResolution2.right, (ScreenResolution2.top + 30));
	}
	else
	{
	MoveTo(0, 0);
	ResizeTo(ScreenResolution2.right, (ScreenResolution2.top + 30));
	}
}

/***************************************************/
void mWindow::Miximize()
{
	if (mctrlview->miBarIsMaximized)
	{
	ResizeTo(20, 30);
	mctrlview->miBarIsMaximized = false;
	}
	else
	{
	ResizeTo(ScreenResolution.right, (ScreenResolution.top + 30));
	mctrlview->miBarIsMaximized = true;
	}
	if (mSPViewShowBool)
	{
	mspview->mUpdateRect.Set(mspview->X, 0, (mspview->X + mspview->mViewWidthX), 30);
	}
}

/**********************************************************/
//Check for updates
int32
mWindow::mBubbleTipsThread_static(void *data)
{
	mWindow *bubbletips = (mWindow *)data;
	bubbletips->mBubbleTipsThread();
	return 0;
}

/**********************************************************/
void mWindow::mBubbleTipsThread()
{
mBubbleMouseLastLocation.Set(1, 1);
MBubble mBubbleTips("mBubbleTips", "OOOOOOOO");
	while (1)
	{
	snooze(500000);
	uint32 location;
	Lock();
	mBubbleMouseLocation.Set(0, 0);
	mctrlview->GetMouse(&mBubbleMouseLocation, &location, true);
		if(mBubbleMouseLastLocation.x == mBubbleMouseLocation.x && mBubbleMouseLastLocation.y == mBubbleMouseLocation.y)
		{
			if (mctrlview->miBarIsMaximized && (mBubbleMouseLastLocation.y >= 2 && mBubbleMouseLastLocation.y <= 25))
			{
				// Popuptips
				if ((mBubbleMouseLastLocation.x > 1 && mBubbleMouseLastLocation.x < 19))
				{
				mBubbleTips.SetText("Minimize and Maximize the iBar");
				mBubbleTips.Show();
				}
				if ((mBubbleMouseLastLocation.x > 21 && mBubbleMouseLastLocation.x < 39))
				{
				mBubbleTips.SetText("Close");
				mBubbleTips.Show();
				}
				if ((mBubbleMouseLastLocation.x > 41 && mBubbleMouseLastLocation.x < 59))
				{
				mBubbleTips.SetText("Preferences");
				mBubbleTips.Show();
				}
				if ((mBubbleMouseLastLocation.x > 61 && mBubbleMouseLastLocation.x < 79))
				{
				mBubbleTips.SetText("Cycle iBar placement");
				mBubbleTips.Show();
				}
				if ((mBubbleMouseLastLocation.x > 81 && mBubbleMouseLastLocation.x < 99))
				{
				mBubbleTips.SetText("About");
				mBubbleTips.Show();
				}
				// Is workspace view there?
				if (mWorkViewBool)
				{
					if ((mBubbleMouseLastLocation.x > 101 && mBubbleMouseLastLocation.x < 119))
					{
					mBubbleTips.SetText("Previous Workspace");
					mBubbleTips.Show();
					}
					if ((mBubbleMouseLastLocation.x > 121 && mBubbleMouseLastLocation.x < 139))
					{
					mBubbleTips.SetText("Next Workspace");
					mBubbleTips.Show();
					}
				}
				mBubbleTipsX = 0;
				if (mCtrlViewBool)
				{ mBubbleTipsX = mCtrlViewWidth + mBubbleTipsX; }
				if (mWorkViewBool)
				{ mBubbleTipsX = mWorkViewWidth + mBubbleTipsX; }
				if (mCPUViewShowBool)
				{ 
					//Bubbletips for cpu view
					if ((mBubbleMouseLastLocation.x > (mBubbleTipsX) && mBubbleMouseLastLocation.x < (mBubbleTipsX + mCPUViewWidth)))
					{
					mBubbleTips.SetText("This view shows the cpu usage");
					mBubbleTips.Show();
					}
				mBubbleTipsX = mCPUViewWidth + mBubbleTipsX; 
				}
				if (mRAMViewShowBool)
				{ 
					//Bubbletips for ram view
					if ((mBubbleMouseLastLocation.x > (mBubbleTipsX) && mBubbleMouseLastLocation.x < (mBubbleTipsX + mRAMViewWidth)))
					{
					mBubbleTips.SetText("This view shows the ram usage");
					mBubbleTips.Show();
					}
				mBubbleTipsX = mRAMViewWidth + mBubbleTipsX; 
				}
				if (mUptimeViewShowBool)
				{ 
					//Bubbletips for uptime view
					if ((mBubbleMouseLastLocation.x > (mBubbleTipsX) && mBubbleMouseLastLocation.x < (mBubbleTipsX + mUptimeViewWidth)))
					{
					mBubbleTips.SetText("This view shows the uptime");
					mBubbleTips.Show();
					}
				mBubbleTipsX = mUptimeViewWidth + mBubbleTipsX; 
				}
				if (mUtilViewShowBool)
				{ 
					//Bubbletips for uptime view
					if ((mBubbleMouseLastLocation.x > (mBubbleTipsX) && mBubbleMouseLastLocation.x < (mBubbleTipsX + mUtilViewWidth)))
					{
					mBubbleTips.SetText("This view shows the average cpu usage");
					mBubbleTips.Show();
					}
				mBubbleTipsX = mUtilViewWidth + mBubbleTipsX; 
				}
				if (mSPViewShowBool)
				{
					if ((mBubbleMouseLastLocation.x > (mBubbleTipsX + 30) && mBubbleMouseLastLocation.x < (mBubbleTipsX + 60)))
					{
					mBubbleTips.SetText(mspview->mSPBubbleTips[0].String());
					mBubbleTips.Show();
					}
					if ((mBubbleMouseLastLocation.x > (mBubbleTipsX + 65) && mBubbleMouseLastLocation.x < (mBubbleTipsX + 95)))
					{
					mBubbleTips.SetText(mspview->mSPBubbleTips[1].String());
					mBubbleTips.Show();
					}
					if ((mBubbleMouseLastLocation.x > (mBubbleTipsX + 100) && mBubbleMouseLastLocation.x < (mBubbleTipsX + 130)))
					{
					mBubbleTips.SetText(mspview->mSPBubbleTips[2].String());
					mBubbleTips.Show();
					}
					if ((mBubbleMouseLastLocation.x > (mBubbleTipsX + 135) && mBubbleMouseLastLocation.x < (mBubbleTipsX + 165)))
					{
					mBubbleTips.SetText(mspview->mSPBubbleTips[3].String());
					mBubbleTips.Show();
					}
					if ((mBubbleMouseLastLocation.x > (mBubbleTipsX + 170) && mBubbleMouseLastLocation.x < (mBubbleTipsX + 200)))
					{
					mBubbleTips.SetText(mspview->mSPBubbleTips[4].String());
					mBubbleTips.Show();
					}
					if ((mBubbleMouseLastLocation.x > (mBubbleTipsX + 205) && mBubbleMouseLastLocation.x < (mBubbleTipsX + 235)))
					{
					mBubbleTips.SetText(mspview->mSPBubbleTips[5].String());
					mBubbleTips.Show();
					}
					if ((mBubbleMouseLastLocation.x > (mBubbleTipsX + 240) && mBubbleMouseLastLocation.x < (mBubbleTipsX + 270)))
					{
					mBubbleTips.SetText(mspview->mSPBubbleTips[6].String());
					mBubbleTips.Show();
					}
				}
			}
		}
		else
		{
		mBubbleTips.Hide();
		}
	mBubbleMouseLastLocation.Set(mBubbleMouseLocation.x, mBubbleMouseLocation.y);
	Unlock();
	}
}
