#ifndef _mWindow_h_
#define _mWindow_h_

#include "mConstant.h"
#include "mCtrlView.h"
#include "mWorkView.h"
#include "mCPUView.h"
#include "mRAMView.h"
#include "mUptimeView.h"
#include "mUtilView.h"
#include "mSPView.h"

class mWindow : public BWindow
{
public:
						mWindow(const char *mWindowTitle);
						~mWindow();
	virtual void 		MessageReceived(BMessage* message);		
	virtual bool 		QuitRequested();
	virtual void		ScreenChanged(BRect size, color_space mode);
	
private:
	void					Miximize();
	color_space 			ScreenDepth;
	//color_space 			ScreenDepth2;
	//BRect					ScreenResolution2;

	mCtrlView*				mctrlview;
	mWorkView*				mworkview;
	mCPUView*				mcpuview;
	mRAMView*				mramview;
	mUptimeView*			muptimeview;
	mUtilView*				mutilview;
	mSPView*				mspview;
		
	FILE*					loadfile;
	FILE*					savefile;
	BString					mScriptsDir;
	BString					mScriptFile;
	BString					mExecDir;
	BPath					path;
	BRect					ScreenResolution;
	int						mCtrlViewWidth, 
								mWorkViewWidth,
								mCPUViewWidth, 
								mRAMViewWidth, 
								mUptimeViewWidth, 
								mUtilViewWidth, 
								mSPViewWidth; 
	int						mCtrlViewPlace,						
								mWorkViewPlace,
								mCPUViewPlace, 
								mRAMViewPlace,
								mUptimeViewPlace, 
								mUtilViewPlace, 
								mSPViewPlace; 
	bool					mCtrlViewBool, 
								mWorkViewBool, 
								mCPUViewShowBool, 
								mRAMViewShowBool, 
								mUptimeViewShowBool, 
								mUtilViewShowBool, 
								mSPViewShowBool;
	int						mViewX, temp;
	int						mCurrentWork, mNextWork;
	bool					mAlignWindowBottom;
	
	status_t				status;
	BFile					file;
	BMessage 				savemessage;
	
	BPoint					mBubbleMouseLocation, mBubbleMouseLastLocation;	
	
	thread_id				mBubbleTips;
	static int32 			mBubbleTipsThread_static(void *data);
	void 					mBubbleTipsThread();
	int						mBubbleTipsX;

};

#endif