//mCPUView.cpp @ Pref
#include "mCPUView.h"

const rgb_color mBack = (ui_color(B_PANEL_BACKGROUND_COLOR));
const rgb_color mBlue = {50, 102, 152, 111};
const rgb_color mBlack = {0, 0, 0, 0};
const rgb_color mWhite = {255, 255, 255, 255};
const rgb_color mDefaultBarColor = {50, 150, 255, 255};

const BRect BR_mCPUMainBoxFrame			(5, 5, 255, 235);
const BRect BR_mCPUColorBoxFrame		(10, 20, 250, 145);
const BRect BR_mCPUColorShowViewFrame	(190, 80, 245, 135);
const BRect BR_mCPUAboutButtonFrame		(105, 202, 130, 222);
const BRect BR_mCPUDefaultButtonFrame	(14, 202, 100, 222);

const BRect BR_mCPUIconBoxFrame			(195, 155, 250, 230);
const BRect BR_mCPUBitmapFrame			(210, 170, 235, 195);
const BRect BR_mCPUNextIconButtonFrame	(200, 202, 245, 220);
									
mCPUView::mCPUView(BRect frame, const char *name, uint32 resizeMask, uint32 flags)
			: BView(BRect(240, 0, 600, 280), "mCPUName", B_FOLLOW_LEFT | B_FOLLOW_TOP,
			 B_WILL_DRAW | B_NAVIGABLE | B_PULSE_NEEDED)
{
MSave savefile("savefile");
MSave loadfile("loadfile");
SetViewColor(mBack);
SetHighColor(mBlack);
SetLowColor(mWhite);
SetDrawingMode(B_OP_OVER);

mCPUAboutButton = new BButton(BR_mCPUAboutButtonFrame, "mCPUAboutButton", "?", 
						new BMessage(MSG_ABOUTCPUVIEW));
mCPUDefaultButton = new BButton(BR_mCPUDefaultButtonFrame, "mCPUDefaultButton",
					 "Default", new BMessage(MSG_CPUDEFAULT));
mCPUNextIconButton = new BButton(BR_mCPUNextIconButtonFrame, "mCPUNextIconButton", "Next",
						new BMessage(MSG_CPUNEXTICON));

//Get colors
find_directory(B_COMMON_SETTINGS_DIRECTORY, &path);
savefile.FindFloat(path, SAVEFILE, "cpuview_color_r", &mCPUColor_r, 50);
savefile.FindFloat(path, SAVEFILE, "cpuview_color_g", &mCPUColor_g, 150);
savefile.FindFloat(path, SAVEFILE, "cpuview_color_b", &mCPUColor_b, 255);
rgb_color mCPUColor = {mCPUColor_r, mCPUColor_g, mCPUColor_b, 255};

// add a color control
mCPUColorControl = new BColorControl(BPoint(15, 35), B_CELLS_16x16, 4, "",
					new BMessage(MSG_CPUCOLORCHANGED), true);
mCPUColorControl->SetValue(mCPUColor);

mCPUColorShowView = new BView(BR_mCPUColorShowViewFrame, NULL, B_FOLLOW_ALL, 0);
mCPUColorShowView->SetViewColor(mCPUColor);

mCPUMainBox = new BBox(BR_mCPUMainBoxFrame, "BR_mCPUMainBox");
mCPUMainBox->SetLabel("CPU View Configuration");
mCPUColorBox = new BBox(BR_mCPUColorBoxFrame, "BR_mCPUMainBox");
mCPUColorBox->SetLabel("Bar Color");
mCPUIconBox = new BBox(BR_mCPUIconBoxFrame, "mCPUIconBox");
mCPUIconBox->SetLabel("Icon");

/*initial icon*/
loadfile.FindString(path, SAVEFILE, "cpuview_icon", &mCPUInitialIcon, ICON1);

mCPUBitmap = BTranslationUtils::GetBitmap(mCPUInitialIcon.String());
mCPUBitmapView = new BitmapView(mCPUBitmap, BR_mCPUBitmapFrame, "mCPUBitmap");
AddChild(mCPUBitmapView);

AddChild(mCPUColorControl);
AddChild(mCPUDefaultButton);
AddChild(mCPUAboutButton);
AddChild(mCPUNextIconButton);
AddChild(mCPUMainBox);
AddChild(mCPUColorBox);
AddChild(mCPUIconBox);
AddChild(mCPUColorShowView);
}

mCPUView::~mCPUView()
{

}

void mCPUView::MessageReceived(BMessage *message)
{
	switch(message->what)
	{
	default:
	
	break;
	}
}

void mCPUView::Draw(BRect update)
{


}

void mCPUView::Pulse()
{

}
