//mRamView.cpp @ Pref
#include "mRAMView.h"

const rgb_color mBack = (ui_color(B_PANEL_BACKGROUND_COLOR));
const rgb_color mBlue = {50, 102, 152, 111};
const rgb_color mBlack = {0, 0, 0, 0};
const rgb_color mWhite = {255, 255, 255, 255};
const rgb_color mDefaultBarColor = {50, 150, 255, 255};

const BRect BR_mRAMMainBoxFrame			(5, 5, 255, 235);
const BRect BR_mRAMColorBoxFrame		(10, 20, 250, 145);
const BRect BR_mRAMColorShowViewFrame	(190, 80, 245, 135);
const BRect BR_mRAMAboutButtonFrame		(105, 202, 130, 222);
const BRect BR_mRAMDefaultButtonFrame	(14, 202, 100, 222);

const BRect BR_mRAMIconBoxFrame			(195, 155, 250, 230);
const BRect BR_mRAMBitmapFrame			(210, 170, 235, 195);
const BRect BR_mRAMNextIconButtonFrame	(200, 202, 245, 220);

mRAMView::mRAMView(BRect frame, const char *name, uint32 resizeMask, uint32 flags)
			: BView(BRect(240, 0, 600, 280), "mRAMName", B_FOLLOW_LEFT | B_FOLLOW_TOP,
			 B_WILL_DRAW | B_NAVIGABLE | B_PULSE_NEEDED)
{
MSave savefile("savefile");
MSave loadfile("loadfile");
SetViewColor(mBack);
SetHighColor(mBlack);
SetLowColor(mWhite);
SetDrawingMode(B_OP_OVER);

mRAMAboutButton = new BButton(BR_mRAMAboutButtonFrame, "mRAMAboutButton", "?", 
						new BMessage(MSG_ABOUTRAMVIEW));
mRAMDefaultButton = new BButton(BR_mRAMDefaultButtonFrame, "mRAMDefaultButton",
					 "Default", new BMessage(MSG_RAMDEFAULT));
mRAMNextIconButton = new BButton(BR_mRAMNextIconButtonFrame, "mRAMNextIconButton", "Next",
						new BMessage(MSG_RAMNEXTICON));

//Get colors
find_directory(B_COMMON_SETTINGS_DIRECTORY, &path);
savefile.FindFloat(path, SAVEFILE, "ramview_color_r", &mRAMColor_r, 50);
savefile.FindFloat(path, SAVEFILE, "ramview_color_g", &mRAMColor_g, 150);
savefile.FindFloat(path, SAVEFILE, "ramview_color_b", &mRAMColor_b, 255);
rgb_color mRAMColor = {mRAMColor_r, mRAMColor_g, mRAMColor_b, 255};

// add a color control
mRAMColorControl = new BColorControl(BPoint(15, 35), B_CELLS_16x16, 4, "",
					new BMessage(MSG_RAMCOLORCHANGED), true);
mRAMColorControl->SetValue(mRAMColor);

mRAMColorShowView = new BView(BR_mRAMColorShowViewFrame, NULL, B_FOLLOW_ALL, 0);
mRAMColorShowView->SetViewColor(mRAMColor);

mRAMMainBox = new BBox(BR_mRAMMainBoxFrame, "BR_mRAMMainBox");
mRAMMainBox->SetLabel("RAM View Configuration");
mRAMColorBox = new BBox(BR_mRAMColorBoxFrame, "BR_mRAMMainBox");
mRAMColorBox->SetLabel("Bar Color");
mRAMIconBox = new BBox(BR_mRAMIconBoxFrame, "mRAMIconBox");
mRAMIconBox->SetLabel("Icon");

/*initial icon*/
loadfile.FindString(path, SAVEFILE, "ramview_icon", &mRAMInitialIcon, ICON2);

mRAMBitmap = BTranslationUtils::GetBitmap(mRAMInitialIcon.String());
mRAMBitmapView = new BitmapView(mRAMBitmap, BR_mRAMBitmapFrame, "mRAMBitmap");
AddChild(mRAMBitmapView);

AddChild(mRAMColorControl);
AddChild(mRAMDefaultButton);
AddChild(mRAMAboutButton);
AddChild(mRAMNextIconButton);
AddChild(mRAMMainBox);
AddChild(mRAMColorBox);
AddChild(mRAMIconBox);
AddChild(mRAMColorShowView);
}

mRAMView::~mRAMView()
{

}

void mRAMView::MessageReceived(BMessage *message)
{
	switch(message->what)
	{
	default:
	
	break;
	}
}

void mRAMView::Draw(BRect update)
{
MovePenTo(50, 50);
DrawString("RAMVIEW");

}

void mRAMView::Pulse()
{
Invalidate();
}
