//mSPView.cpp @ Pref
#include "mSPView.h"

const BRect BR_mSPBoxFrame				(5, 5, 255, 235);
const BRect BR_mSPAboutButtonFrame		(105, 202, 130, 222);
const BRect BR_mSPDefaultButtonFrame	(14, 202, 100, 222);
const BRect	BR_mSPCheckBoxBoxFrame		(15, 30, 140, 190);

const BRect BR_mSPBackCheckBoxFrame		(20, 45, 130, 65);
const BRect BR_mSPFRewCheckBoxFrame		(20, 65, 130, 75);
const BRect BR_mSPRewCheckBoxFrame	 	(20, 85, 130, 95);
const BRect BR_mSPStopCheckBoxFrame		(20, 105, 130, 115);
const BRect BR_mSPForwCheckBoxFrame		(20, 125, 130, 135);
const BRect BR_mSPFForwCheckBoxFrame	(20, 145, 130, 155);
const BRect BR_mSPNextCheckBoxFrame		(20, 165, 130, 175);

const BRect BR_mSPNextIconButtonFrame	(150, 162, 195, 180);
const BRect BR_mSPBitmapFrame			(160, 130, 185, 155);
const BRect	BR_mSPIconBoxFrame			(145, 115, 200, 190);

const rgb_color mBack = (ui_color(B_PANEL_BACKGROUND_COLOR));
const rgb_color mBlue = {50, 102, 152, 111};
const rgb_color mBlack = {0, 0, 0, 0};
const rgb_color mWhite = {255, 255, 255, 255};

mSPView::mSPView(BRect frame, const char *name, uint32 resizeMask, uint32 flags)
			: BView(BRect(240, 0, 500, 280), "mSPName", B_FOLLOW_LEFT | B_FOLLOW_TOP,
			 B_WILL_DRAW | B_NAVIGABLE | B_PULSE_NEEDED)
{
MSave loadfile("loadfile");
SetViewColor(mBack);
SetHighColor(mBlack);
SetLowColor(mWhite);
SetDrawingMode(B_OP_OVER);

mSPNextIconButton = new BButton(BR_mSPNextIconButtonFrame, "mSPNextIconButton", "Next", new BMessage(MSG_SPNEXTICON));

mSPIconBox = new BBox(BR_mSPIconBoxFrame, "mSPIconBox");
mSPIconBox->SetLabel("Icon");

mSPDefaultButton = new BButton(BR_mSPDefaultButtonFrame, "mSPDefaultButton", "Default", 
					new BMessage(MSG_SPDEFAULT));
mSPAboutButton = new BButton(BR_mSPAboutButtonFrame, "mSPAboutButton", "?", new BMessage(MSG_ABOUTSPVIEW));
mSPCheckBoxBox = new BBox(BR_mSPCheckBoxBoxFrame, "mSPCheckBoxBox");
mSPCheckBoxBox->SetLabel("Button selection");
mSPBackCheckBox = new BCheckBox(BR_mSPBackCheckBoxFrame, "mSPBackCheckBox", "Previous song", 
					new BMessage(MSG_SPCHECKBOXES));
mSPFRewCheckBox = new BCheckBox(BR_mSPFRewCheckBoxFrame, "mSPFRewCheckBox", "Fast backward", 
					new BMessage(MSG_SPCHECKBOXES));
mSPRewCheckBox = new BCheckBox(BR_mSPRewCheckBoxFrame, "mSPRewCheckBox", "Play backwards", 
					new BMessage(MSG_SPCHECKBOXES));
mSPStopCheckBox = new BCheckBox(BR_mSPStopCheckBoxFrame, "mSPStopCheckBox", "Stop", 
					new BMessage(MSG_SPCHECKBOXES));
mSPForwCheckBox = new BCheckBox(BR_mSPForwCheckBoxFrame, "mSPForwCheckBox", "Play", 
					new BMessage(MSG_SPCHECKBOXES));
mSPFForwCheckBox = new BCheckBox(BR_mSPFForwCheckBoxFrame, "mSPFForwCheckBox", "Fast forward", 
					new BMessage(MSG_SPCHECKBOXES));
mSPNextCheckBox = new BCheckBox(BR_mSPNextCheckBoxFrame, "mSPNextCheckBox", "Next song", 
					new BMessage(MSG_SPCHECKBOXES));

// Which buttons to show
find_directory(B_COMMON_SETTINGS_DIRECTORY, &path);
/*1*/
loadfile.FindBool(path, SAVEFILE, "spview_b1", &mShowBool, 1);
mSPBackCheckBox->SetValue(mShowBool);
/*2*/
loadfile.FindBool(path, SAVEFILE, "spview_b2", &mShowBool, 0);
mSPFRewCheckBox->SetValue(mShowBool);
/*3*/
loadfile.FindBool(path, SAVEFILE, "spview_b3", &mShowBool, 0);
mSPRewCheckBox->SetValue(mShowBool);
/*4*/
loadfile.FindBool(path, SAVEFILE, "spview_b4", &mShowBool, 1);
mSPStopCheckBox->SetValue(mShowBool);
/*5*/
loadfile.FindBool(path, SAVEFILE, "spview_b5", &mShowBool, 1);
mSPForwCheckBox->SetValue(mShowBool);
/*6*/
loadfile.FindBool(path, SAVEFILE, "spview_b6", &mShowBool, 0);
mSPFForwCheckBox->SetValue(mShowBool);
/*7*/
loadfile.FindBool(path, SAVEFILE, "spview_b7", &mShowBool, 1);
mSPNextCheckBox->SetValue(mShowBool);
/*init icon*/
loadfile.FindString(path, SAVEFILE, "spview_icon", &mSPInitialIcon, ICON3);
	
mSPBitmap = BTranslationUtils::GetBitmap(mSPInitialIcon.String());
mSPBitmapView = new BitmapView(mSPBitmap, BR_mSPBitmapFrame, "mSPBitmap");
AddChild(mSPBitmapView);	
	
mSPBox = new BBox(BR_mSPBoxFrame, "mSPBox");
mSPBox->SetLabel("SoundPlay Control Configuration");

AddChild(mSPBackCheckBox);
AddChild(mSPFRewCheckBox);
AddChild(mSPRewCheckBox);
AddChild(mSPStopCheckBox);
AddChild(mSPForwCheckBox);
AddChild(mSPFForwCheckBox);
AddChild(mSPNextCheckBox);
AddChild(mSPAboutButton);
AddChild(mSPDefaultButton);
AddChild(mSPNextIconButton);
AddChild(mSPCheckBoxBox);
AddChild(mSPIconBox);
AddChild(mSPBox);
}

mSPView::~mSPView()
{

}

void mSPView::MessageReceived(BMessage *message)
{
	switch(message->what)
	{
	default:
	
	break;
	}
}

void mSPView::Draw(BRect update)
{

}

void mSPView::Pulse()
{
Invalidate();
}
