//mWindow.cpp @ pref
#include "mWindow.h"
#include "main.h"

const rgb_color mBlue = 					{90, 85, 205};
const rgb_color mDefault = 					{219, 219, 219};
const rgb_color mWhite = 					{255, 255, 255};
const rgb_color mBlack = 					{1, 1, 1, 40};

const char* mWindowTitle =					"iBar Preferences";
const char* mSaveSettingsFilename =			SAVEFILE;

const BRect mWindowRect 					(100, 100, 340, 340);

//Constructa
mWindow::mWindow(const char *mWindowTitle)
			: BWindow(BRect(mWindowRect), mWindowTitle, B_TITLED_WINDOW, B_NOT_RESIZABLE)
{
MSave savefile("savefile");
MSave loadfile("loadfile");

// Add the views
mmainview = new mMainView(BRect(0, 0, 100, 280), "mMainView", B_FOLLOW_TOP | B_FOLLOW_LEFT, B_WILL_DRAW | B_NOT_RESIZABLE | B_NAVIGABLE);
AddChild(mmainview);
mworkview = new mWorkView(BRect(240, 0, 600, 280), "mWorkView", B_FOLLOW_TOP | B_FOLLOW_LEFT, B_WILL_DRAW | B_NOT_RESIZABLE | B_NAVIGABLE);
AddChild(mworkview);
mworkview->Hide();
mcpuview = new mCPUView(BRect(240, 0, 600, 280), "mCPUView", B_FOLLOW_TOP | B_FOLLOW_LEFT, B_WILL_DRAW | B_NOT_RESIZABLE | B_NAVIGABLE);
AddChild(mcpuview);
mcpuview->Hide();
mramview = new mRAMView(BRect(240, 0, 600, 280), "mRAMView", B_FOLLOW_TOP | B_FOLLOW_LEFT, B_WILL_DRAW | B_NOT_RESIZABLE | B_NAVIGABLE);
AddChild(mramview);
mramview->Hide();
muptimeview = new mUptimeView(BRect(240, 0, 600, 280), "mUptimeView", B_FOLLOW_TOP | B_FOLLOW_LEFT, B_WILL_DRAW | B_NOT_RESIZABLE | B_NAVIGABLE);
AddChild(muptimeview);
muptimeview->Hide();
mutilview = new mUtilView(BRect(240, 0, 600, 280), "mUtilView", B_FOLLOW_TOP | B_FOLLOW_LEFT, B_WILL_DRAW | B_NOT_RESIZABLE | B_NAVIGABLE);
AddChild(mutilview);
mutilview->Hide();
mspview = new mSPView(BRect(240, 0, 600, 280), "mSPView", B_FOLLOW_TOP | B_FOLLOW_LEFT, B_WILL_DRAW | B_NOT_RESIZABLE | B_NAVIGABLE);
AddChild(mspview);
mspview->Hide();

mSomethingExpandedBool = mWorkExpandedBool = mCPUExpandedBool = mRAMExpandedBool = 
						mUptimeExpandedBool = mUtilExpandedBool = mSPExpandedBool = 0;
						
find_directory(B_COMMON_SETTINGS_DIRECTORY, &path);
float temp;
//Set what number in the line the default icons are
loadfile.FindFloat(path, SAVEFILE, "spview_icon_nr", &temp, 2);
mSPIconNumber = temp;
loadfile.FindFloat(path, SAVEFILE, "cpuview_icon_nr", &temp, 0);
mCPUIconNumber = temp;
loadfile.FindFloat(path, SAVEFILE, "ramview_icon_nr", &temp, 1);
mRAMIconNumber = temp;
loadfile.FindFloat(path, SAVEFILE, "utilview_icon_nr", &temp, 4);
mUtilIconNumber = temp;
loadfile.FindFloat(path, SAVEFILE, "uptimeview_icon_nr", &temp, 3);
mUptimeIconNumber = temp;


mStringIcons[0].SetTo(ICON1);
mStringIcons[1].SetTo(ICON2);
mStringIcons[2].SetTo(ICON3);
mStringIcons[3].SetTo(ICON4);
mStringIcons[4].SetTo(ICON5);
mStringIcons[5].SetTo(ICON6);
mStringIcons[6].SetTo(ICON7);
mStringIcons[7].SetTo(ICON8);
mStringIcons[8].SetTo(ICON9);
mStringIcons[9].SetTo(ICON10);
mStringIcons[10].SetTo(ICON11);
mStringIcons[11].SetTo(ICON12);
mStringIcons[12].SetTo(ICON13);
mStringIcons[13].SetTo(ICON14);
}

/**************************************************************/
mWindow::~mWindow()
{

}

/**************************************************************/
/**************** BMessages ***********************************/
/**************************	************************************/
void mWindow::MessageReceived(BMessage *message)
{
MSave savefile("savefile");
MSave loadfile("loadfile");
find_directory(B_COMMON_SETTINGS_DIRECTORY, &path);
	switch (message->what)
	{
	case MSG_UPTIMENEXTICON:
		mIconNumbers = ICONS;
		mUptimeIconNumber++;
		
		cout << mUptimeIconNumber << endl;
			if ((mIconNumbers - 1) >= mUptimeIconNumber)
			{
			}
			else
			{
			mUptimeIconNumber = 0;
			}
			/**/
			find_directory(B_COMMON_SETTINGS_DIRECTORY, &path);
			savefile.AddString(path, SAVEFILE, "uptimeview_icon", mStringIcons[mUptimeIconNumber].String() , true);
			savefile.AddFloat(path, SAVEFILE, "uptimeview_icon_nr", (float)mUptimeIconNumber , true);
			
			cout << mStringIcons[mUptimeIconNumber].String() << endl;
			muptimeview->mUptimeBitmap = BTranslationUtils::GetBitmap(mStringIcons[mUptimeIconNumber].String());
			muptimeview->mUptimeBitmapView->SetBitmap(muptimeview->mUptimeBitmap);
			muptimeview->RemoveChild(muptimeview->mUptimeBitmapView);
			muptimeview->AddChild(muptimeview->mUptimeBitmapView);
	break;
	case MSG_UPTIMEDEFAULT:
		/*default icon*/
		find_directory(B_COMMON_SETTINGS_DIRECTORY, &path);
		savefile.AddString(path, SAVEFILE, "uptimeview_icon", ICON4 , true);
		savefile.AddFloat(path, SAVEFILE, "uptimeview_icon_nr", (float)mUptimeIconNumber , true);
		
		muptimeview->mUptimeBitmap = BTranslationUtils::GetBitmap(ICON4);
		muptimeview->mUptimeBitmapView->SetBitmap(muptimeview->mUptimeBitmap);
		muptimeview->RemoveChild(muptimeview->mUptimeBitmapView);
		muptimeview->AddChild(muptimeview->mUptimeBitmapView);
		mUptimeIconNumber = 3;
	break;
	case MSG_ABOUTUPTIMEVIEW:
	{
	mAlert = new BAlert("MSG_ABOUTUPTIMEVIEW", "This is the configuration for the Uptime View\nHere you can set its icon. This view shows the PC's uptime", 
						"OK", 0, 0, B_WIDTH_AS_USUAL, B_OFFSET_SPACING, B_INFO_ALERT);
	mAlert->Go();
	break;
	}
	case MSG_ABOUTUTILVIEW:
	{
	mAlert = new BAlert("MSG_ABOUTUTILVIEW", "This is the configuration for the Utilization View\nHere you can set its icon. This view shows the average CPU load", 
						"OK", 0, 0, B_WIDTH_AS_USUAL, B_OFFSET_SPACING, B_INFO_ALERT);
	mAlert->Go();
	break;
	}
	case MSG_UTILNEXTICON:
		mIconNumbers = ICONS;
		mUtilIconNumber++;
		
		cout << mUtilIconNumber << endl;
			if ((mIconNumbers - 1) >= mUtilIconNumber)
			{
			}
			else
			{
			mUtilIconNumber = 0;
			}
			/**/
			find_directory(B_COMMON_SETTINGS_DIRECTORY, &path);
			savefile.AddString(path, SAVEFILE, "utilview_icon", mStringIcons[mUtilIconNumber].String() , true);
			savefile.AddFloat(path, SAVEFILE, "utilview_icon_nr", (float)mUtilIconNumber , true);
			
			cout << mStringIcons[mUtilIconNumber].String() << endl;
			mutilview->mUtilBitmap = BTranslationUtils::GetBitmap(mStringIcons[mUtilIconNumber].String());
			mutilview->mUtilBitmapView->SetBitmap(mutilview->mUtilBitmap);
			mutilview->RemoveChild(mutilview->mUtilBitmapView);
			mutilview->AddChild(mutilview->mUtilBitmapView);
	break;
	case MSG_UTILDEFAULT:
		/*default icon*/
		find_directory(B_COMMON_SETTINGS_DIRECTORY, &path);
		savefile.AddString(path, SAVEFILE, "utilview_icon", ICON5 , true);
		savefile.AddFloat(path, SAVEFILE, "utilview_icon_nr", (float)mUtilIconNumber , true);
		
		mutilview->mUtilBitmap = BTranslationUtils::GetBitmap(ICON5);
		mutilview->mUtilBitmapView->SetBitmap(mutilview->mUtilBitmap);
		mutilview->RemoveChild(mutilview->mUtilBitmapView);
		mutilview->AddChild(mutilview->mUtilBitmapView);
		mUtilIconNumber = 4;
	break;
	case MSG_ABOUTRAMVIEW:
	{
	mAlert = new BAlert("MSG_ABOUTRAMVIEW", "This is the configuration for the RAM View\nHere you can set the RAM Usage Bar Color,\nand its ram icon", 
						"OK", 0, 0, B_WIDTH_AS_USUAL, B_OFFSET_SPACING, B_INFO_ALERT);
	mAlert->Go();
	break;
	}
	case MSG_RAMNEXTICON:
		mIconNumbers = ICONS;
		mRAMIconNumber++;
		
		cout << mRAMIconNumber << endl;
			if ((mIconNumbers - 1) >= mRAMIconNumber)
			{
			}
			else
			{
			mRAMIconNumber = 0;
			}
			/**/
			find_directory(B_COMMON_SETTINGS_DIRECTORY, &path);
			savefile.AddString(path, SAVEFILE, "ramview_icon", mStringIcons[mRAMIconNumber].String() , true);
			savefile.AddFloat(path, SAVEFILE, "ramview_icon_nr", (float)mRAMIconNumber , true);
			
			cout << mStringIcons[mRAMIconNumber].String() << endl;
			mramview->mRAMBitmap = BTranslationUtils::GetBitmap(mStringIcons[mRAMIconNumber].String());
			mramview->mRAMBitmapView->SetBitmap(mramview->mRAMBitmap);
			mramview->RemoveChild(mramview->mRAMBitmapView);
			mramview->AddChild(mramview->mRAMBitmapView);
	break;
	case MSG_RAMDEFAULT:
	{
		rgb_color tempahh = {50, 150, 255, 255};
		mramview->mRAMColorControl->SetValue(tempahh);
		PostMessage(MSG_RAMCOLORCHANGED);
		/*default icon*/
		find_directory(B_COMMON_SETTINGS_DIRECTORY, &path);
		savefile.AddString(path, SAVEFILE, "ramview_icon", ICON2 , true);
		savefile.AddFloat(path, SAVEFILE, "ramview_icon_nr", (float)mRAMIconNumber , true);
		
		mramview->mRAMBitmap = BTranslationUtils::GetBitmap(ICON2);
		mramview->mRAMBitmapView->SetBitmap(mramview->mRAMBitmap);
		mramview->RemoveChild(mramview->mRAMBitmapView);
		mramview->AddChild(mramview->mRAMBitmapView);
		mRAMIconNumber = 1;
	break;
	}
	case MSG_RAMCOLORCHANGED:
		mramview->mRAMColorShowView->SetViewColor(mramview->mRAMColorControl->ValueAsColor());
		mramview->mRAMColorShowView->Invalidate();
		rgb_color temprgccolor (mramview->mRAMColorControl->ValueAsColor());
		savefile.AddFloat(path, SAVEFILE, "ramview_color_r", temprgccolor.red, true);
		savefile.AddFloat(path, SAVEFILE, "ramview_color_g", temprgccolor.green, true);
		savefile.AddFloat(path, SAVEFILE, "ramview_color_b", temprgccolor.blue, true);
	break;
	case MSG_CPUNEXTICON:
		mIconNumbers = ICONS;
		mCPUIconNumber++;
		
		cout << mCPUIconNumber << endl;
			if ((mIconNumbers - 1) >= mCPUIconNumber)
			{
			}
			else
			{
			mCPUIconNumber = 0;
			}
			/**/
			find_directory(B_COMMON_SETTINGS_DIRECTORY, &path);
			savefile.AddString(path, SAVEFILE, "cpuview_icon", mStringIcons[mCPUIconNumber].String() , true);
			savefile.AddFloat(path, SAVEFILE, "cpuview_icon_nr", (float)mCPUIconNumber , true);
			
			cout << mStringIcons[mCPUIconNumber].String() << endl;
			mcpuview->mCPUBitmap = BTranslationUtils::GetBitmap(mStringIcons[mCPUIconNumber].String());
			mcpuview->mCPUBitmapView->SetBitmap(mcpuview->mCPUBitmap);
			mcpuview->RemoveChild(mcpuview->mCPUBitmapView);
			mcpuview->AddChild(mcpuview->mCPUBitmapView);
	break;
	case MSG_ABOUTCPUVIEW:
	{
	mAlert = new BAlert("MSG_ABOUTCPUVIEW", "This is the configuration for the CPU View\nHere you can set the CPU Usage Bar Color,\nand its cpu icon", 
						"OK", 0, 0, B_WIDTH_AS_USUAL, B_OFFSET_SPACING, B_INFO_ALERT);
	mAlert->Go();
	break;
	}
	case MSG_CPUDEFAULT:
	{
		rgb_color tempahh = {50, 150, 255, 255};
		mcpuview->mCPUColorControl->SetValue(tempahh);
		PostMessage(MSG_CPUCOLORCHANGED);
		/*default icon*/
		find_directory(B_COMMON_SETTINGS_DIRECTORY, &path);
		savefile.AddString(path, SAVEFILE, "cpuview_icon", ICON1 , true);
		savefile.AddFloat(path, SAVEFILE, "cpuview_icon_nr", (float)mCPUIconNumber , true);
		
		mcpuview->mCPUBitmap = BTranslationUtils::GetBitmap(ICON1);
		mcpuview->mCPUBitmapView->SetBitmap(mcpuview->mCPUBitmap);
		mcpuview->RemoveChild(mcpuview->mCPUBitmapView);
		mcpuview->AddChild(mcpuview->mCPUBitmapView);
		mCPUIconNumber = 0;
	break;
	}
	case MSG_CPUCOLORCHANGED:
		mcpuview->mCPUColorShowView->SetViewColor(mcpuview->mCPUColorControl->ValueAsColor());
		mcpuview->mCPUColorShowView->Invalidate();
		rgb_color temprg_ccolor (mcpuview->mCPUColorControl->ValueAsColor());
		savefile.AddFloat(path, SAVEFILE, "cpuview_color_r", temprg_ccolor.red, true);
		savefile.AddFloat(path, SAVEFILE, "cpuview_color_g", temprg_ccolor.green, true);
		savefile.AddFloat(path, SAVEFILE, "cpuview_color_b", temprg_ccolor.blue, true);
	break;
	case MSG_RESTARTIBAR:
	{
	/*
		BMessage killit;
		BMessage sendkillit;
		BMessenger killitmsng;
		sendkillit.AddSpecifier("Window");
		
		if (BMessenger("application/x-vnd.iBar").SendMessage(&sendkillit, &killit) == B_OK)
		{
			if (killit.FindMessenger("result", &killitmsng) == B_OK)
			{
				killitmsng.SendMessage(B_QUIT_REQUESTED);
				cout << "a" << endl;
			}
		}
	*/
	system("kill -9 iBar");
	BString	miBarPath;
	loadfile.FindString(path, SAVEFILE, "execDir", &miBarPath, "/boot/apps/iBar/");
	miBarPath.Append("/iBar &");
	system(miBarPath.String());
	break;
	}
	case MSG_SPNEXTICON:
		mIconNumbers = ICONS;
		mSPIconNumber++;
		
		cout << mSPIconNumber << endl;
			if ((mIconNumbers - 1) >= mSPIconNumber)
			{
			}
			else
			{
			mSPIconNumber = 0;
			}
			/**/
			find_directory(B_COMMON_SETTINGS_DIRECTORY, &path);
			savefile.AddString(path, SAVEFILE, "spview_icon", mStringIcons[mSPIconNumber].String() , true);
			savefile.AddFloat(path, SAVEFILE, "spview_icon_nr", (float)mSPIconNumber , true);
			
			cout << mStringIcons[mSPIconNumber].String() << endl;
			mspview->mSPBitmap = BTranslationUtils::GetBitmap(mStringIcons[mSPIconNumber].String());
			mspview->mSPBitmapView->SetBitmap(mspview->mSPBitmap);
			mspview->RemoveChild(mspview->mSPBitmapView);
			mspview->AddChild(mspview->mSPBitmapView);
	break;
	case MSG_SPDEFAULT:
		mspview->mSPBackCheckBox->SetValue(1);
		mspview->mSPFRewCheckBox->SetValue(0);
		mspview->mSPRewCheckBox->SetValue(0);
		mspview->mSPStopCheckBox->SetValue(1);
		mspview->mSPForwCheckBox->SetValue(1);
		mspview->mSPFForwCheckBox->SetValue(0);
		mspview->mSPNextCheckBox->SetValue(1);
		/*default icon*/
		find_directory(B_COMMON_SETTINGS_DIRECTORY, &path);
		savefile.AddString(path, SAVEFILE, "spview_icon", ICON3 , true);
		savefile.AddFloat(path, SAVEFILE, "spview_icon_nr", (float)mSPIconNumber , true);
		
		mspview->mSPBitmap = BTranslationUtils::GetBitmap(ICON3);
		mspview->mSPBitmapView->SetBitmap(mspview->mSPBitmap);
		mspview->RemoveChild(mspview->mSPBitmapView);
		mspview->AddChild(mspview->mSPBitmapView);
		mSPIconNumber = 2;
		PostMessage(MSG_SPCHECKBOXES);
	break;
	case MSG_SPCHECKBOXES:
		find_directory(B_COMMON_SETTINGS_DIRECTORY, &path);
		savefile.AddBool(path, SAVEFILE, "spview_b1", mspview->mSPBackCheckBox->Value() , true);
		savefile.AddBool(path, SAVEFILE, "spview_b2", mspview->mSPFRewCheckBox->Value() , true);
		savefile.AddBool(path, SAVEFILE, "spview_b3", mspview->mSPRewCheckBox->Value() , true);
		savefile.AddBool(path, SAVEFILE, "spview_b4", mspview->mSPStopCheckBox->Value() , true);
		savefile.AddBool(path, SAVEFILE, "spview_b5", mspview->mSPForwCheckBox->Value() , true);
		savefile.AddBool(path, SAVEFILE, "spview_b6", mspview->mSPFForwCheckBox->Value() , true);
		savefile.AddBool(path, SAVEFILE, "spview_b7", mspview->mSPNextCheckBox->Value() , true);
	break;
	case MSG_ABOUTSPVIEW:
	{
	mAlert = new BAlert("MSG_ABOUTSPVIEW", "This is the configuration for the SoundPlay Control\nHere you can set which buttons to show,\nand what icon to use....\n\n\"Dont say a word!\"\n\"OK\"", 
						"OK", 0, 0, B_WIDTH_AS_USUAL, B_OFFSET_SPACING, B_INFO_ALERT);
	mAlert->Go();
	break;
	}
	case MSG_QUIT:
		be_app->PostMessage(B_QUIT_REQUESTED);
	break;
	/************************************/
	case MSG_WORKCHECK:
		if (mmainview->mWorkBox->Value() == 0)
		{
		mmainview->mWorkButton->SetEnabled(false);
			if (mWorkExpandedBool)
			{
				if (mmainview->mFancyBox->Value() == 1)
				{
					for (int a = 0; a < 130; a++)
					{
					ResizeTo(Bounds().right - 2, Bounds().bottom);
					snooze(1000);
					}
				}
				else
				{
				ResizeTo(Bounds().right - 260, Bounds().bottom);
				}
			if (mcpuview->IsHidden() == 0){ mcpuview->Hide(); }
			if (mramview->IsHidden() == 0){ mramview->Hide(); }
			if (muptimeview->IsHidden() == 0){ muptimeview->Hide(); }
			if (mutilview->IsHidden() == 0){ mutilview->Hide(); }
			if (mspview->IsHidden() == 0){ mspview->Hide(); }
			if (mworkview->IsHidden() == 0){ mworkview->Hide(); }
			mWorkExpandedBool = mSomethingExpandedBool = mCPUExpandedBool = mRAMExpandedBool = 
						mUptimeExpandedBool = mUtilExpandedBool = mSPExpandedBool = false;
			mmainview->mWorkButton->SetLabel("Details >>");
			}
		}
		else
		{
		//fix ? (disabled because there are no Work Preferences)
		//mmainview->mWorkButton->SetEnabled(true);
		}
		savefile.AddBool(path, SAVEFILE, "workview_bool", mmainview->mWorkBox->Value() , true);
	break;
	/***************************/
	case MSG_CPUCHECK:
		if (mmainview->mCPUBox->Value() == 0)
		{
		mmainview->mCPUButton->SetEnabled(false);
			if (mCPUExpandedBool)
			{
				if (mmainview->mFancyBox->Value() == 1)
				{
					for (int a = 0; a < 130; a++)
					{
					ResizeTo(Bounds().right - 2, Bounds().bottom);
					snooze(1000);
					}
				}
				else
				{
				ResizeTo(Bounds().right - 260, Bounds().bottom);
				}
			if (mcpuview->IsHidden() == 0){ mcpuview->Hide(); }
			if (mramview->IsHidden() == 0){ mramview->Hide(); }
			if (muptimeview->IsHidden() == 0){ muptimeview->Hide(); }
			if (mutilview->IsHidden() == 0){ mutilview->Hide(); }
			if (mspview->IsHidden() == 0){ mspview->Hide(); }
			if (mworkview->IsHidden() == 0){ mworkview->Hide(); }
			mWorkExpandedBool = mSomethingExpandedBool = mCPUExpandedBool = mRAMExpandedBool = 
						mUptimeExpandedBool = mUtilExpandedBool = mSPExpandedBool = false;
			mmainview->mCPUButton->SetLabel("Details >>");
			}
		}
		else
		{
		mmainview->mCPUButton->SetEnabled(true);
		}
		savefile.AddBool(path, SAVEFILE, "cpuview_bool", mmainview->mCPUBox->Value() , true);
	break;
	/***************************/
	case MSG_RAMCHECK:
		if (mmainview->mRAMBox->Value() == 0)
		{
		mmainview->mRAMButton->SetEnabled(false);
			if (mRAMExpandedBool)
			{
				if (mmainview->mFancyBox->Value() == 1)
				{
					for (int a = 0; a < 130; a++)
					{
					ResizeTo(Bounds().right - 2, Bounds().bottom);
					snooze(1000);
					}
				}
				else
				{
				ResizeTo(Bounds().right - 260, Bounds().bottom);
				}
			if (mcpuview->IsHidden() == 0){ mcpuview->Hide(); }
			if (mramview->IsHidden() == 0){ mramview->Hide(); }
			if (muptimeview->IsHidden() == 0){ muptimeview->Hide(); }
			if (mutilview->IsHidden() == 0){ mutilview->Hide(); }
			if (mspview->IsHidden() == 0){ mspview->Hide(); }
			if (mworkview->IsHidden() == 0){ mworkview->Hide(); }
			mWorkExpandedBool = mSomethingExpandedBool = mCPUExpandedBool = mRAMExpandedBool = 
						mUptimeExpandedBool = mUtilExpandedBool = mSPExpandedBool = false;
			mmainview->mRAMButton->SetLabel("Details >>");
			}
		}
		else
		{
		mmainview->mRAMButton->SetEnabled(true);
		}
		savefile.AddBool(path, SAVEFILE, "ramview_bool", mmainview->mRAMBox->Value() , true);
	break;
	/***************************/
	case MSG_UPTIMECHECK:
		if (mmainview->mUptimeBox->Value() == 0)
		{
		mmainview->mUptimeButton->SetEnabled(false);
			if (mUptimeExpandedBool)
			{
				if (mmainview->mFancyBox->Value() == 1)
				{
					for (int a = 0; a < 130; a++)
					{
					ResizeTo(Bounds().right - 2, Bounds().bottom);
					snooze(1000);
					}
				}
				else
				{
				ResizeTo(Bounds().right - 260, Bounds().bottom);
				}
			if (mcpuview->IsHidden() == 0){ mcpuview->Hide(); }
			if (mramview->IsHidden() == 0){ mramview->Hide(); }
			if (muptimeview->IsHidden() == 0){ muptimeview->Hide(); }
			if (mutilview->IsHidden() == 0){ mutilview->Hide(); }
			if (mspview->IsHidden() == 0){ mspview->Hide(); }
			if (mworkview->IsHidden() == 0){ mworkview->Hide(); }
			mWorkExpandedBool = mSomethingExpandedBool = mCPUExpandedBool = mRAMExpandedBool = 
						mUptimeExpandedBool = mUtilExpandedBool = mSPExpandedBool = false;
			mmainview->mUptimeButton->SetLabel("Details >>");
			}
		}
		else
		{
		mmainview->mUptimeButton->SetEnabled(true);
		}
		savefile.AddBool(path, SAVEFILE, "uptimeview_bool", mmainview->mUptimeBox->Value() , true);
	break;
	/***************************/
	case MSG_UTILCHECK:
		if (mmainview->mUtilBox->Value() == 0)
		{
		mmainview->mUtilButton->SetEnabled(false);
			if (mUtilExpandedBool)
			{
				if (mmainview->mFancyBox->Value() == 1)
				{
					for (int a = 0; a < 130; a++)
					{
					ResizeTo(Bounds().right - 2, Bounds().bottom);
					snooze(1000);
					}
				}
				else
				{
				ResizeTo(Bounds().right - 260, Bounds().bottom);
				}
			if (mcpuview->IsHidden() == 0){ mcpuview->Hide(); }
			if (mramview->IsHidden() == 0){ mramview->Hide(); }
			if (muptimeview->IsHidden() == 0){ muptimeview->Hide(); }
			if (mutilview->IsHidden() == 0){ mutilview->Hide(); }
			if (mspview->IsHidden() == 0){ mspview->Hide(); }
			if (mworkview->IsHidden() == 0){ mworkview->Hide(); }
			mWorkExpandedBool = mSomethingExpandedBool = mCPUExpandedBool = mRAMExpandedBool = 
						mUptimeExpandedBool = mUtilExpandedBool = mSPExpandedBool = false;
			mmainview->mUtilButton->SetLabel("Details >>");
			}
		}
		else
		{
		mmainview->mUtilButton->SetEnabled(true);
		}
		savefile.AddBool(path, SAVEFILE, "utilview_bool", mmainview->mUtilBox->Value() , true);
	break;
	/***************************/
	case MSG_SPCHECK:
		if (mmainview->mSPBox->Value() == 0)
		{
		mmainview->mSPButton->SetEnabled(false);
			if (mSPExpandedBool)
			{
				if (mmainview->mFancyBox->Value() == 1)
				{
					for (int a = 0; a < 130; a++)
					{
					ResizeTo(Bounds().right - 2, Bounds().bottom);
					snooze(1000);
					}
				}
				else
				{
				ResizeTo(Bounds().right - 260, Bounds().bottom);
				}
			if (mcpuview->IsHidden() == 0){ mcpuview->Hide(); }
			if (mramview->IsHidden() == 0){ mramview->Hide(); }
			if (muptimeview->IsHidden() == 0){ muptimeview->Hide(); }
			if (mutilview->IsHidden() == 0){ mutilview->Hide(); }
			if (mspview->IsHidden() == 0){ mspview->Hide(); }
			if (mworkview->IsHidden() == 0){ mworkview->Hide(); }
			mWorkExpandedBool = mSomethingExpandedBool = mCPUExpandedBool = mRAMExpandedBool = 
						mUptimeExpandedBool = mUtilExpandedBool = mSPExpandedBool = false;
			mmainview->mSPButton->SetLabel("Details >>");
			}
		}
		else
		{
		mmainview->mSPButton->SetEnabled(true);
		}
		savefile.AddBool(path, SAVEFILE, "spview_bool", mmainview->mSPBox->Value() , true);
	break;
	/************************************************/
	case MSG_WORKCLICK:
	if (mSomethingExpandedBool)
	{
		if (mWorkExpandedBool)
		{
			if (mmainview->mFancyBox->Value() == 1)
			{
				for (int a = 0; a < 130; a++)
				{
				ResizeTo(Bounds().right - 2, Bounds().bottom);
				snooze(1000);
				}
			}
			else
			{
			ResizeTo(Bounds().right - 260, Bounds().bottom);
			}
			if (mcpuview->IsHidden() == 0){ mcpuview->Hide(); }
			if (mramview->IsHidden() == 0){ mramview->Hide(); }
			if (muptimeview->IsHidden() == 0){ muptimeview->Hide(); }
			if (mutilview->IsHidden() == 0){ mutilview->Hide(); }
			if (mspview->IsHidden() == 0){ mspview->Hide(); }
			if (mworkview->IsHidden() == 0){ mworkview->Hide(); }
		mWorkExpandedBool = mSomethingExpandedBool = mCPUExpandedBool = mRAMExpandedBool = 
						mUptimeExpandedBool = mUtilExpandedBool = mSPExpandedBool = false;
		mmainview->mWorkButton->SetLabel("Details >>");
		}
		else
		{
			if (mmainview->mFancyBox->Value() == 1)
			{
				for (int a = 0; a < 130; a++)
				{
				ResizeTo(Bounds().right - 2, Bounds().bottom);
				snooze(1000);
				}
				for (int a = 0; a < 130; a++)
				{
				ResizeTo(Bounds().right + 2, Bounds().bottom);
				snooze(1000);
				}
			}
		LockLooper();
			if (mcpuview->IsHidden() == 0){ mcpuview->Hide(); }
			if (mramview->IsHidden() == 0){ mramview->Hide(); }
			if (muptimeview->IsHidden() == 0){ muptimeview->Hide(); }
			if (mutilview->IsHidden() == 0){ mutilview->Hide(); }
			if (mspview->IsHidden() == 0){ mspview->Hide(); }
		mworkview->Show();
		UnlockLooper();
		mWorkExpandedBool = true;
		mSomethingExpandedBool = true;
		mCPUExpandedBool = mRAMExpandedBool = mUptimeExpandedBool = 
							mUtilExpandedBool = mSPExpandedBool = false;
		mmainview->mWorkButton->SetLabel("<< Details");
		mmainview->mCPUButton->SetLabel("Details >>");
		mmainview->mRAMButton->SetLabel("Details >>");
		mmainview->mUptimeButton->SetLabel("Details >>");
		mmainview->mUtilButton->SetLabel("Details >>");
		mmainview->mSPButton->SetLabel("Details >>");
		}
	}
	else
	{	
		LockLooper();
		mworkview->Show();
		UnlockLooper();
		
		
		
		if (mmainview->mFancyBox->Value() == 1)
		{	
			for (int a = 0; a < 130; a++)
			{
			ResizeTo(Bounds().right + 2, Bounds().bottom);
			snooze(1000);
			}
		}
		else
		{
		ResizeTo(Bounds().right + 260, Bounds().bottom);
		}
	mWorkExpandedBool = true;
	mSomethingExpandedBool = true;
	mCPUExpandedBool = mRAMExpandedBool = mUptimeExpandedBool = 
							mUtilExpandedBool = mSPExpandedBool = false;
	mmainview->mWorkButton->SetLabel("<< Details");
	}
	break;
	/***************************/
	case MSG_CPUCLICK:
	if (mSomethingExpandedBool)
	{
		if (mCPUExpandedBool)
		{
			if (mmainview->mFancyBox->Value() == 1)
			{
				for (int a = 0; a < 130; a++)
				{
				ResizeTo(Bounds().right - 2, Bounds().bottom);
				snooze(1000);
				}
			}
			else
			{
			ResizeTo(Bounds().right - 260, Bounds().bottom);
			}
			if (mcpuview->IsHidden() == 0){ mcpuview->Hide(); }
			if (mramview->IsHidden() == 0){ mramview->Hide(); }
			if (muptimeview->IsHidden() == 0){ muptimeview->Hide(); }
			if (mutilview->IsHidden() == 0){ mutilview->Hide(); }
			if (mspview->IsHidden() == 0){ mspview->Hide(); }
			if (mworkview->IsHidden() == 0){ mworkview->Hide(); }
		mWorkExpandedBool = mSomethingExpandedBool = mCPUExpandedBool = mRAMExpandedBool = 
						mUptimeExpandedBool = mUtilExpandedBool = mSPExpandedBool = false;
		mmainview->mCPUButton->SetLabel("Details >>");
		}
		else
		{
			if (mmainview->mFancyBox->Value() == 1)
			{
				for (int a = 0; a < 130; a++)
				{
				ResizeTo(Bounds().right - 2, Bounds().bottom);
				snooze(1000);
				}
				for (int a = 0; a < 130; a++)
				{
				ResizeTo(Bounds().right + 2, Bounds().bottom);
				snooze(1000);
				}
			}
		LockLooper();
			if (mramview->IsHidden() == 0){ mramview->Hide(); }
			if (muptimeview->IsHidden() == 0){ muptimeview->Hide(); }
			if (mutilview->IsHidden() == 0){ mutilview->Hide(); }
			if (mspview->IsHidden() == 0){ mspview->Hide(); }
			if (mworkview->IsHidden() == 0){ mworkview->Hide(); }		
		mcpuview->Show();
		UnlockLooper();
		mCPUExpandedBool = true;
		mSomethingExpandedBool = true;
		mWorkExpandedBool = mRAMExpandedBool = mUptimeExpandedBool = 
							mUtilExpandedBool = mSPExpandedBool = false;
		mmainview->mCPUButton->SetLabel("<< Details");
		mmainview->mWorkButton->SetLabel("Details >>");
		mmainview->mRAMButton->SetLabel("Details >>");
		mmainview->mUptimeButton->SetLabel("Details >>");
		mmainview->mUtilButton->SetLabel("Details >>");
		mmainview->mSPButton->SetLabel("Details >>");
		}
	}
	else
	{
		LockLooper();
		mcpuview->Show();
		UnlockLooper();
		if (mmainview->mFancyBox->Value() == 1)
		{	
			for (int a = 0; a < 130; a++)
			{
			ResizeTo(Bounds().right + 2, Bounds().bottom);
			snooze(1000);
			}
		}
		else
		{
		ResizeTo(Bounds().right + 260, Bounds().bottom);
		}
	mCPUExpandedBool = true;
	mSomethingExpandedBool = true;
	mWorkExpandedBool = mRAMExpandedBool = mUptimeExpandedBool = 
							mUtilExpandedBool = mSPExpandedBool = false;
	mmainview->mCPUButton->SetLabel("<< Details");
	}	
	break;
	/***************************/
	case MSG_RAMCLICK:
	if (mSomethingExpandedBool)
	{
		if (mRAMExpandedBool)
		{
			if (mmainview->mFancyBox->Value() == 1)
			{
				for (int a = 0; a < 130; a++)
				{
				ResizeTo(Bounds().right - 2, Bounds().bottom);
				snooze(1000);
				}
			}
			else
			{
			ResizeTo(Bounds().right - 260, Bounds().bottom);
			}
			if (mcpuview->IsHidden() == 0){ mcpuview->Hide(); }
			if (mramview->IsHidden() == 0){ mramview->Hide(); }
			if (muptimeview->IsHidden() == 0){ muptimeview->Hide(); }
			if (mutilview->IsHidden() == 0){ mutilview->Hide(); }
			if (mspview->IsHidden() == 0){ mspview->Hide(); }
			if (mworkview->IsHidden() == 0){ mworkview->Hide(); }
		mWorkExpandedBool = mSomethingExpandedBool = mCPUExpandedBool = mRAMExpandedBool = 
						mUptimeExpandedBool = mUtilExpandedBool = mSPExpandedBool = false;
		mmainview->mRAMButton->SetLabel("Details >>");
		}
		else
		{
			if (mmainview->mFancyBox->Value() == 1)
			{
				for (int a = 0; a < 130; a++)
				{
				ResizeTo(Bounds().right - 2, Bounds().bottom);
				snooze(1000);
				}
				for (int a = 0; a < 130; a++)
				{
				ResizeTo(Bounds().right + 2, Bounds().bottom);
				snooze(1000);
				}
			}
		LockLooper();
			if (mcpuview->IsHidden() == 0){ mcpuview->Hide(); }
			if (muptimeview->IsHidden() == 0){ muptimeview->Hide(); }
			if (mutilview->IsHidden() == 0){ mutilview->Hide(); }
			if (mspview->IsHidden() == 0){ mspview->Hide(); }
			if (mworkview->IsHidden() == 0){ mworkview->Hide(); }
		mramview->Show();
		UnlockLooper();
		mRAMExpandedBool = true;
		mSomethingExpandedBool = true;
		mWorkExpandedBool = mCPUExpandedBool = mUptimeExpandedBool = 
							mUtilExpandedBool = mSPExpandedBool = false;
		mmainview->mRAMButton->SetLabel("<< Details");
		mmainview->mWorkButton->SetLabel("Details >>");
		mmainview->mCPUButton->SetLabel("Details >>");
		mmainview->mUptimeButton->SetLabel("Details >>");
		mmainview->mUtilButton->SetLabel("Details >>");
		mmainview->mSPButton->SetLabel("Details >>");
		}
	}
	else
	{
		LockLooper();
		mramview->Show();
		UnlockLooper();
		if (mmainview->mFancyBox->Value() == 1)
		{	
			for (int a = 0; a < 130; a++)
			{
			ResizeTo(Bounds().right + 2, Bounds().bottom);
			snooze(1000);
			}
		}
		else
		{
		ResizeTo(Bounds().right + 260, Bounds().bottom);
		}
	mRAMExpandedBool = true;
	mSomethingExpandedBool = true;
	mWorkExpandedBool = mCPUExpandedBool = mUptimeExpandedBool = 
							mUtilExpandedBool = mSPExpandedBool = false;
	mmainview->mRAMButton->SetLabel("<< Details");
	}
	break;
	/***************************/
	case MSG_UPTIMECLICK:
		if (mSomethingExpandedBool)
	{
		if (mUptimeExpandedBool)
		{
			if (mmainview->mFancyBox->Value() == 1)
			{
				for (int a = 0; a < 130; a++)
				{
				ResizeTo(Bounds().right - 2, Bounds().bottom);
				snooze(1000);
				}
			}
			else
			{
			ResizeTo(Bounds().right - 260, Bounds().bottom);
			}
			if (mcpuview->IsHidden() == 0){ mcpuview->Hide(); }
			if (mramview->IsHidden() == 0){ mramview->Hide(); }
			if (muptimeview->IsHidden() == 0){ muptimeview->Hide(); }
			if (mutilview->IsHidden() == 0){ mutilview->Hide(); }
			if (mspview->IsHidden() == 0){ mspview->Hide(); }
			if (mworkview->IsHidden() == 0){ mworkview->Hide(); }
		mWorkExpandedBool = mSomethingExpandedBool = mCPUExpandedBool = mRAMExpandedBool = 
						mUptimeExpandedBool = mUtilExpandedBool = mSPExpandedBool = false;
		mmainview->mUptimeButton->SetLabel("Details >>");
		}
		else
		{
			if (mmainview->mFancyBox->Value() == 1)
			{
				for (int a = 0; a < 130; a++)
				{
				ResizeTo(Bounds().right - 2, Bounds().bottom);
				snooze(1000);
				}
				for (int a = 0; a < 130; a++)
				{
				ResizeTo(Bounds().right + 2, Bounds().bottom);
				snooze(1000);
				}
			}
		LockLooper();
			if (mcpuview->IsHidden() == 0){ mcpuview->Hide(); }
			if (mramview->IsHidden() == 0){ mramview->Hide(); }
			if (mutilview->IsHidden() == 0){ mutilview->Hide(); }
			if (mspview->IsHidden() == 0){ mspview->Hide(); }
			if (mworkview->IsHidden() == 0){ mworkview->Hide(); }
		muptimeview->Show();
		UnlockLooper();
		mUptimeExpandedBool = true;
		mSomethingExpandedBool = true;
		mWorkExpandedBool = mCPUExpandedBool = mRAMExpandedBool = 
							mUtilExpandedBool = mSPExpandedBool = false;
		mmainview->mUptimeButton->SetLabel("<< Details");
		mmainview->mWorkButton->SetLabel("Details >>");
		mmainview->mCPUButton->SetLabel("Details >>");
		mmainview->mRAMButton->SetLabel("Details >>");
		mmainview->mUtilButton->SetLabel("Details >>");
		mmainview->mSPButton->SetLabel("Details >>");
		}
	}
	else
	{
		LockLooper();
		muptimeview->Show();
		UnlockLooper();
		if (mmainview->mFancyBox->Value() == 1)
		{	
			for (int a = 0; a < 130; a++)
			{
			ResizeTo(Bounds().right + 2, Bounds().bottom);
			snooze(1000);
			}
		}
		else
		{
		ResizeTo(Bounds().right + 260, Bounds().bottom);
		}
	mUptimeExpandedBool = true;
	mSomethingExpandedBool = true;
	mWorkExpandedBool = mCPUExpandedBool = mRAMExpandedBool = 
							mUtilExpandedBool = mSPExpandedBool = false;
	mmainview->mUptimeButton->SetLabel("<< Details");
	}	
	break;
	/***************************/
	case MSG_UTILCLICK:
		if (mSomethingExpandedBool)
	{
		if (mUtilExpandedBool)
		{
			if (mmainview->mFancyBox->Value() == 1)
			{
				for (int a = 0; a < 130; a++)
				{
				ResizeTo(Bounds().right - 2, Bounds().bottom);
				snooze(1000);
				}
			}
			else
			{
			ResizeTo(Bounds().right - 260, Bounds().bottom);
			}
			if (mcpuview->IsHidden() == 0){ mcpuview->Hide(); }
			if (mramview->IsHidden() == 0){ mramview->Hide(); }
			if (muptimeview->IsHidden() == 0){ muptimeview->Hide(); }
			if (mutilview->IsHidden() == 0){ mutilview->Hide(); }
			if (mspview->IsHidden() == 0){ mspview->Hide(); }
			if (mworkview->IsHidden() == 0){ mworkview->Hide(); }
		mWorkExpandedBool = mSomethingExpandedBool = mCPUExpandedBool = mRAMExpandedBool = 
						mUptimeExpandedBool = mUtilExpandedBool = mSPExpandedBool = false;
		mmainview->mUtilButton->SetLabel("Details >>");
		}
		else
		{
			if (mmainview->mFancyBox->Value() == 1)
			{
				for (int a = 0; a < 130; a++)
				{
				ResizeTo(Bounds().right - 2, Bounds().bottom);
				snooze(1000);
				}
				for (int a = 0; a < 130; a++)
				{
				ResizeTo(Bounds().right + 2, Bounds().bottom);
				snooze(1000);
				}
			}
		LockLooper();
			if (mcpuview->IsHidden() == 0){ mcpuview->Hide(); }
			if (mramview->IsHidden() == 0){ mramview->Hide(); }
			if (muptimeview->IsHidden() == 0){ muptimeview->Hide(); }
			if (mspview->IsHidden() == 0){ mspview->Hide(); }
			if (mworkview->IsHidden() == 0){ mworkview->Hide(); }
		mutilview->Show();
		UnlockLooper();
		mUtilExpandedBool = true;
		mSomethingExpandedBool = true;
		mWorkExpandedBool = mCPUExpandedBool = mUptimeExpandedBool = 
							mRAMExpandedBool = mSPExpandedBool = false;
		mmainview->mUtilButton->SetLabel("<< Details");
		mmainview->mWorkButton->SetLabel("Details >>");
		mmainview->mCPUButton->SetLabel("Details >>");
		mmainview->mUptimeButton->SetLabel("Details >>");
		mmainview->mRAMButton->SetLabel("Details >>");
		mmainview->mSPButton->SetLabel("Details >>");
		}
	}
	else
	{
		LockLooper();
		mutilview->Show();
		UnlockLooper();
		if (mmainview->mFancyBox->Value() == 1)
		{	
			for (int a = 0; a < 130; a++)
			{
			ResizeTo(Bounds().right + 2, Bounds().bottom);
			snooze(1000);
			}
		}
		else
		{
		ResizeTo(Bounds().right + 260, Bounds().bottom);
		}
	mUtilExpandedBool = true;
	mSomethingExpandedBool = true;
	mWorkExpandedBool = mCPUExpandedBool = mUptimeExpandedBool = 
							mRAMExpandedBool = mSPExpandedBool = false;
	mmainview->mUtilButton->SetLabel("<< Details");
	}	
	break;
	/***************************/
	case MSG_SPCLICK:
	if (mSomethingExpandedBool)
	{
		if (mSPExpandedBool)
		{
			if (mmainview->mFancyBox->Value() == 1)
			{
				for (int a = 0; a < 130; a++)
				{
				ResizeTo(Bounds().right - 2, Bounds().bottom);
				snooze(1000);
				}
			}
			else
			{
			ResizeTo(Bounds().right - 260, Bounds().bottom);
			}
			if (mcpuview->IsHidden() == 0){ mcpuview->Hide(); }
			if (mramview->IsHidden() == 0){ mramview->Hide(); }
			if (muptimeview->IsHidden() == 0){ muptimeview->Hide(); }
			if (mutilview->IsHidden() == 0){ mutilview->Hide(); }
			if (mspview->IsHidden() == 0){ mspview->Hide(); }
			if (mworkview->IsHidden() == 0){ mworkview->Hide(); }
		mWorkExpandedBool = mSomethingExpandedBool = mCPUExpandedBool = mRAMExpandedBool = 
						mUptimeExpandedBool = mUtilExpandedBool = mSPExpandedBool = false;
		mmainview->mSPButton->SetLabel("Details >>");
		}
		else
		{
			if (mmainview->mFancyBox->Value() == 1)
			{
				for (int a = 0; a < 130; a++)
				{
				ResizeTo(Bounds().right - 2, Bounds().bottom);
				snooze(1000);
				}
				for (int a = 0; a < 130; a++)
				{
				ResizeTo(Bounds().right + 2, Bounds().bottom);
				snooze(1000);
				}
			}
		LockLooper();
			if (mcpuview->IsHidden() == 0){ mcpuview->Hide(); }
			if (mramview->IsHidden() == 0){ mramview->Hide(); }
			if (muptimeview->IsHidden() == 0){ muptimeview->Hide(); }
			if (mutilview->IsHidden() == 0){ mutilview->Hide(); }
			if (mworkview->IsHidden() == 0){ mworkview->Hide(); }
		mspview->Show();	
		UnlockLooper();
		mSPExpandedBool = true;
		mSomethingExpandedBool = true;
		mWorkExpandedBool = mCPUExpandedBool = mUptimeExpandedBool = 
							mUtilExpandedBool = mRAMExpandedBool = false;
		mmainview->mSPButton->SetLabel("<< Details");
		mmainview->mWorkButton->SetLabel("Details >>");
		mmainview->mCPUButton->SetLabel("Details >>");
		mmainview->mUptimeButton->SetLabel("Details >>");
		mmainview->mUtilButton->SetLabel("Details >>");
		mmainview->mRAMButton->SetLabel("Details >>");
		}
	}
	else
	{
		LockLooper();
		mspview->Show();
		UnlockLooper();
		if (mmainview->mFancyBox->Value() == 1)
		{	
			for (int a = 0; a < 130; a++)
			{
			ResizeTo(Bounds().right + 2, Bounds().bottom);
			snooze(1000);
			}
		}
		else
		{
		ResizeTo(Bounds().right + 260, Bounds().bottom);
		}
	mSPExpandedBool = true;
	mSomethingExpandedBool = true;
	mWorkExpandedBool = mCPUExpandedBool = mUptimeExpandedBool = 
							mUtilExpandedBool = mRAMExpandedBool = false;
	mmainview->mSPButton->SetLabel("<< Details");
	}	
	break;
	case MSG_FANCY:
		find_directory(B_COMMON_SETTINGS_DIRECTORY, &path);
		mFancyResize = mmainview->mFancyBox->Value();
		savefile.AddBool(path, SAVEFILE, "mainview_fancy", mmainview->mFancyBox->Value() , true);
	break;
	default:
		
	break;
	}
}

/***************************************************/
bool mWindow::QuitRequested()
{
	be_app->PostMessage(B_QUIT_REQUESTED);
	return BWindow::QuitRequested();
}