#include "Save.h"

MSave::MSave(const char* name) : BMessage('pref')
{

}

/**************/
MSave::~MSave()
{

}

/********************/
status_t MSave::AddString(BPath folderpath,
							 const char* filename, 
							 const char* savename, 
							 const char* save_text, 
							 bool replace)
{
folderpath.Append(filename);
status = file.SetTo(folderpath.Path(), B_READ_WRITE | B_CREATE_FILE);
	if (status == B_OK) 
	{
	status = savemessage.Unflatten(&file);
	}
	
	if (savemessage.HasString(savename) == 0)
	{
	savemessage.AddString(savename, save_text);
	}
	else
	{
		if(replace)
		{
		savemessage.ReplaceString(savename, save_text);
		}
	}
	
	if (file.SetTo(folderpath.Path(), B_READ_WRITE | B_CREATE_FILE) == B_OK) 
	{
	savemessage.Flatten(&file);
	}
	
return(0);
}

/*******************/
status_t MSave::AddFloat(BPath folderpath, 
							const char* filename, 
							const char* savename, 
							float save_float, 
							bool replace)
{
folderpath.Append(filename);
status = file.SetTo(folderpath.Path(), B_READ_WRITE | B_CREATE_FILE);
	if (status == B_OK) 
	{
	status = savemessage.Unflatten(&file);
	}
	
	if (savemessage.HasFloat(savename) == 0)
	{
	savemessage.AddFloat(savename, save_float);
	}
	else
	{
		if(replace)
		{
		savemessage.ReplaceFloat(savename, save_float);
		}
	}
	
	if (file.SetTo(folderpath.Path(), B_READ_WRITE | B_CREATE_FILE) == B_OK) 
	{
	savemessage.Flatten(&file);
	}
	
return(0);
}

/**********************/
status_t MSave::AddBool(BPath folderpath, 
							const char* filename, 
							const char* savename, 
							bool save_bool, 
							bool replace)
{
folderpath.Append(filename);
status = file.SetTo(folderpath.Path(), B_READ_WRITE | B_CREATE_FILE);
	if (status == B_OK) 
	{
	status = savemessage.Unflatten(&file);
	}
	
	if (savemessage.HasBool(savename) == 0)
	{
	savemessage.AddBool(savename, save_bool);
	}
	else
	{
		if(replace)
		{
		savemessage.ReplaceBool(savename, save_bool);
		}
	}
	
	if (file.SetTo(folderpath.Path(), B_READ_WRITE | B_CREATE_FILE) == B_OK) 
	{
	savemessage.Flatten(&file);
	}
	
return(0);
}

/****************************/
status_t MSave::FindString(BPath folderpath, 
								const char* filename, 
								const char* savename, 
								BString* load_to_string, 
								const char* default_string)
{
folderpath.Append(filename);
status = file.SetTo(folderpath.Path(), B_READ_WRITE | B_CREATE_FILE);
	if (status == B_OK) 
	{
	status = savemessage.Unflatten(&file);
	}
	
	if (savemessage.HasString(savename) == 0)
	{
	savemessage.AddString(savename, default_string);
	}
	savemessage.FindString(savename, load_to_string);
	
	if (file.SetTo(folderpath.Path(), B_READ_WRITE | B_CREATE_FILE) == B_OK) 
	{
	savemessage.Flatten(&file);
	}
	/*?*/
return (0);
}

/****************************/
status_t MSave::FindFloat(BPath folderpath, 
								const char* filename, 
								const char* savename, 
								float* load_to_float, 
								float default_float)
{
folderpath.Append(filename);
status = file.SetTo(folderpath.Path(), B_READ_WRITE | B_CREATE_FILE);
	if (status == B_OK) 
	{
	status = savemessage.Unflatten(&file);
	}
	
	if (savemessage.HasFloat(savename) == 0)
	{
	savemessage.AddFloat(savename, default_float);
	}
	savemessage.FindFloat(savename, load_to_float);
	
	if (file.SetTo(folderpath.Path(), B_READ_WRITE | B_CREATE_FILE) == B_OK) 
	{
	savemessage.Flatten(&file);
	}
	/*?*/
return (*load_to_float);
}

/****************************/
status_t MSave::FindBool(BPath folderpath, 
							const char* filename, 
							const char* savename, 
							bool* load_to_bool, 
							bool default_bool)
{
folderpath.Append(filename);
status = file.SetTo(folderpath.Path(), B_READ_WRITE | B_CREATE_FILE);
	if (status == B_OK) 
	{
	status = savemessage.Unflatten(&file);
	}
	
	if (savemessage.HasBool(savename) == 0)
	{
	savemessage.AddBool(savename, default_bool);
	}
	savemessage.FindBool(savename, load_to_bool);
	
	if (file.SetTo(folderpath.Path(), B_READ_WRITE | B_CREATE_FILE) == B_OK) 
	{
	savemessage.Flatten(&file);
	}
	
return (*load_to_bool);
}
