#ifndef _Save_h_
#define _Save_h_

#include <InterfaceKit.h>
#include <AppKit.h>
#include <StorageKit.h>
#include <SupportKit.h>
#include <TranslationKit.h>


class _EXPORT MSave	: public BMessage	{
	public:
					MSave(const char* name);
	virtual			~MSave();
	
	status_t		AddString(BPath folderpath, 
								const char* filename, 
								const char* savename, 
								const char* save_text,
								bool replace);
								
	status_t		AddFloat(BPath folderpath, 
								const char* filename, 
								const char* savename, 
								float save_float,
								bool replace);
								
	status_t		AddBool(BPath folderpath, 
								const char* filename, 
								const char* savename, 
								bool save_bool,
								bool replace);
								
	status_t		FindString(BPath folderpath,
								const char* filename,
								const char* savename,
								BString* load_to_string,
								const char* default_string);
								
	status_t		FindFloat(BPath folderpath,
								const char* filename,
								const char* savename,
								float* load_to_float,
								float default_float);
	
	status_t		FindBool(BPath folderpath,
								const char* filename,
								const char* savename,
								bool* load_to_bool,
								bool default_bool);
	private:
	BMessage savemessage;
	status_t status;
	BFile file;

};

#endif